#!
#
#   GD Demo Application - Tcl/Tk script
#


# ----------------------------------------------------- global variables

set Aux_Split_List {}
set Orientation_List {}
set Polygonal_List {}

set current_orientation 0
set auto_orient_inserted_edge off

set current_polygonal default


# ------------------------------------------------------ top level layout of the main window
frame       .menu          -relief raised   -borderwidth 1 
pack        .menu          -side top -fill  x

frame .buttons_frame
pack  .buttons_frame -side top  -fill x -pady 2m


frame .debug_frame

### (un)comment this for debug widgets 
#pack .debug_frame -side top -fill x

frame .panel_frame
pack .panel_frame -side top -fill x -ipady 5

frame .draw_frame
pack .draw_frame -side top -fill both -expand yes










# ------------------------------------------------------ menu frame

#menubutton .menu.file -text "File"       -menu .menu.file.m -underline 0
#pack       .menu.file -side left -padx 2m -pady 1m


#menu    .menu.file.m
#        .menu.file.m add command -label "Quit"            -underline 0 -command exit









menubutton .menu.polygonal -text "Drawing"     -menu .menu.polygonal.m -underline 0
pack       .menu.polygonal -side left -padx 2m -pady 1m

menu    .menu.polygonal.m 
        .menu.polygonal.m add command     -label "New" -underline 0 -command {
	     set current_polygonal [GD_Polygonal new]
	     lappend Polygonal_List $current_polygonal
	     Update_radios
	     .menu.polygonal.m entryconfigure "Delete" -state normal
	     Emit_status
	     }
        .menu.polygonal.m add command     -label "Clone" -underline 0 -command {
	     set current_polygonal [GD_Polygonal clone]
	     lappend Polygonal_List $current_polygonal
	     Update_radios
	     .menu.polygonal.m entryconfigure "Delete" -state normal
	     Emit_status
	     }
        .menu.polygonal.m add command     -label "Delete" -underline 0 -state disabled -command {
	     GD_Polygonal delete $current_polygonal; #delete the object
	     
	     set k [lsearch $Polygonal_List $current_polygonal ]
	     set Polygonal_List [lreplace $Polygonal_List $k $k]
	     Update_radios
	     
	     set current_polygonal default; #defalut current Polygonal
	     .menu.polygonal.m entryconfigure "Delete" -state disabled; #it can't delete anything
	     Emit_status
	     }
        .menu.polygonal.m add separator 
        .menu.polygonal.m add command     -label "Random" -underline 0 -command "GD_Polygonal random; Emit_status"
        .menu.polygonal.m add command     -label "Complete Sugiyama" -underline 0 -command "GD_Layering sugituning_clear; Emit_status"
        .menu.polygonal.m add command     -label "No Clear Sugiyama" -underline 0 -command { lappend Aux_Split_List [GD_Layering sugituning]; Emit_status; Update_radios; }

	     
	









menubutton .menu.orientation -text "Orientation"     -menu .menu.orientation.m -underline 0
pack       .menu.orientation -side left -padx 2m -pady 1m

menu    .menu.orientation.m 
        .menu.orientation.m add command     -label "New" -underline 0 -command {
	     set current_orientation [GD_Orientation new]
	     lappend Orientation_List $current_orientation
	     Update_radios
#	     .menu.orientation.m add radiobutton -label $current_orientation -variable current_orientation -value $current_orientation -command {
#	                GD_Orientation set_current $current_orientation
#	                .menu.orientation.m entryconfigure "Delete" -state normal
#			Emit_status
#			}
	     .menu.orientation.m entryconfigure "Delete" -state normal
	     Emit_status
	     }
        .menu.orientation.m add command     -label "Clone" -underline 0 -command {
	     set current_orientation [GD_Orientation clone]
	     lappend Orientation_List $current_orientation
	     Update_radios
	     .menu.orientation.m entryconfigure "Delete" -state normal
	     Emit_status
	     }
        .menu.orientation.m add command     -label "Delete" -underline 0 -state disabled -command {
	     GD_Orientation delete ; #delete the object
	     
	     set k [lsearch $Orientation_List $current_orientation ]
	     set Orientation_List [lreplace $Orientation_List $k $k]
	     Update_radios

	     set current_orientation 0; #no current orientation
	     .menu.orientation.m entryconfigure "Delete" -state disabled; #it can't delete anything
	     Emit_status
	     }
        .menu.orientation.m add separator
        .menu.orientation.m add command     -label "Random" -underline 0 -command "GD_Orientation random"
	.menu.orientation.m add command     -label "Switch cycl info"     -command "GD_Oriented_Cycles_Info; Emit_status"
        .menu.orientation.m add checkbutton -label "Auto Orientation" -variable "auto_orient_inserted_edge" -offvalue "off" -onvalue "on"
	





menubutton .menu.window -text "Window"     -menu .menu.window.m -underline 0
pack       .menu.window -side left -padx 2m -pady 1m
menu    .menu.window.m
        .menu.window.m add command -label "Info Window"  -underline 0 -command {
              catch { toplevel .info_frame }
	      wm title .info_frame "Info Window"
              text .info_frame.t -relief sunken -bd 2 \
                                 -yscrollcommand ".info_frame.scroll set" -setgrid 1 \
              		   -width 50\
              		   -height 60\
              		   -state disabled
              scrollbar .info_frame.scroll -command ".info_frame.t yview"
              pack .info_frame.scroll -side right  -fill y
              pack .info_frame.t   -fill both -expand yes
	      Emit_status
	      }




# ------------------------------------------------------  button frame


button .buttons_frame.connect_info -text "Conn. Info"\
                                   -command "GD_ConnectedInfo ; Emit_status"


button .buttons_frame.complete_sugiyama -text "Complete Sugiyama"\
                                        -command {.menu.polygonal.m invoke 6}

button .buttons_frame.no_clear_sugiyama -text "No clear Sugiyama"\
                                        -command {.menu.polygonal.m invoke 7}

button .buttons_frame.cycl_info -text "Switch Cycl Info"\
                                        -command {.menu.orientation.m invoke 6}





pack \
    .buttons_frame.complete_sugiyama \
    .buttons_frame.no_clear_sugiyama \
    .buttons_frame.cycl_info \
    .buttons_frame.connect_info \
    -side left




# ------------------------------------------------------  draw frame
canvas .draw_frame.c -scrollregion {0c 0c 30c  24c  } \
                  -width 15c -height 15c \
                  -relief sunken -borderwidth 2 \
                  -xscrollcommand ".draw_frame.hscroll set" \
                  -yscrollcommand ".draw_frame.vscroll set"

        # for scrollbar -command specify a prefix for the notification command
scrollbar .draw_frame.vscroll               -command ".draw_frame.c yview"
scrollbar .draw_frame.hscroll -orient horiz -command ".draw_frame.c xview"

pack .draw_frame.hscroll   -side bottom -fill x
pack .draw_frame.vscroll   -side right -fill y
pack .draw_frame.c  .draw_frame -expand yes -fill both


# -------------------------------------------- panel_frame


frame .panel_frame.logo  
pack .panel_frame.logo -side left -expand 1
  label .panel_frame.logo.l1 -justify center -anchor s -text "ECO" 
  pack  .panel_frame.logo.l1 -side top 
  label .panel_frame.logo.l2 -justify center -anchor n -text "demo application"
  pack  .panel_frame.logo.l2 -side top 
  


proc Update_radios {} {
    global Aux_Split_List Orientation_List Polygonal_List
    global current_orientation current_polygonal

    catch { destroy .panel_frame.polygonal }
    frame .panel_frame.polygonal  -bd 3 -relief groove 
    pack .panel_frame.polygonal -side left -fill both
       label .panel_frame.polygonal.title  -bd 3 -relief groove -text "Drawing"
       pack .panel_frame.polygonal.title  -side top  -fill x
       radiobutton .panel_frame.polygonal.default  -text "default" -variable current_polygonal -value "default"  -anchor w  -command {
	                GD_Polygonal set_current default
	                .menu.polygonal.m entryconfigure "Delete" -state disabled
			Emit_status
			}
       pack .panel_frame.polygonal.default -side top -fill x


    set q 0
    foreach i $Polygonal_List {
        radiobutton .panel_frame.polygonal.x$q  -text $i -variable current_polygonal -value $i -command {
	                GD_Polygonal set_current $current_polygonal
	                .menu.polygonal.m entryconfigure "Delete" -state normal
			Emit_status
			}
	pack .panel_frame.polygonal.x$q -side top
	set q [expr $q + 1]
        }





    catch { destroy .panel_frame.orientation }
    frame .panel_frame.orientation  -bd 3 -relief groove 
    pack .panel_frame.orientation -side left -fill both 
       label  .panel_frame.orientation.title -bd 3 -relief groove -text "Orientation"
       pack .panel_frame.orientation.title  -side top -fill x
       button .panel_frame.orientation.none -text "None" -relief flat -anchor w -bd 0 -command {
                        set current_orientation "none"
	                GD_Orientation set_current none
	                .menu.orientation.m entryconfigure "Delete" -state disabled
			Emit_status
			}
       pack .panel_frame.orientation.none  -side top -fill x
       


    set q 0
    foreach i $Orientation_List {
        radiobutton .panel_frame.orientation.x$q  -text $i -variable current_orientation -value $i -command {
	                GD_Orientation set_current $current_orientation
	                .menu.orientation.m entryconfigure "Delete" -state normal
			Emit_status
			}
	pack .panel_frame.orientation.x$q -side top
	set q [expr $q + 1]
        }



    catch { destroy .panel_frame.aux_split }
    frame .panel_frame.aux_split  -bd 3 -relief groove
    pack .panel_frame.aux_split -side left -fill both
       label  .panel_frame.aux_split.title  -bd 3 -relief groove -text "Ficticious V."
       pack .panel_frame.aux_split.title  -side top  -fill x 


    set q 0
    foreach i $Aux_Split_List {
	
	frame .panel_frame.aux_split.x$q 
        pack .panel_frame.aux_split.x$q  -side top 
	
        label  .panel_frame.aux_split.x$q.item -text $i
	pack .panel_frame.aux_split.x$q.item -side left
	
	button .panel_frame.aux_split.x$q.b1 -text "del" -pady 0 -command "Del_aux_split $i"
	pack .panel_frame.aux_split.x$q.b1 -side left

	button .panel_frame.aux_split.x$q.b2 -text "chk" -pady 0
        bind .panel_frame.aux_split.x$q.b2 <ButtonPress-1>  "GD_Show_Label splits $i"
	bind .panel_frame.aux_split.x$q.b2 <ButtonRelease-1>  "GD_Show_Label user"
	pack .panel_frame.aux_split.x$q.b2 -side left
	

	set q [expr $q + 1]
        }
    pack .panel_frame.logo -side left -fill both -after .panel_frame.aux_split
    }
    
proc Del_aux_split {i} {
    global Aux_Split_List
    GD_Unsplit_All $i
    Emit_status
    set k [lsearch -exact $Aux_Split_List $i]
    set Aux_Split_List  [lreplace $Aux_Split_List $k $k]
    Update_radios
    }
    
    
    
    
    

# --------------------------------------------------------- debug_frame
text .debug_frame.t -relief sunken -bd 2 \
                   -width 30 -heigh 3
button .debug_frame.b -text "tcl eval" -command {
            set x [.debug_frame.t get 1.0 end]
	    puts "evaluating <$x>"
            eval $x
	    }
button .debug_frame.winfo -text "winfo"  -command {\
					    puts [winfo children .]
					    foreach i [winfo children .] {
					        puts [winfo children $i]
						}
					    }
					    
					    
text .debug_frame.info -relief sunken -bd 2 \
                   -width 50 -heigh 1 \
		   -state disabled
					    
pack \
    .debug_frame.winfo \
    .debug_frame.b \
    .debug_frame.t \
    .debug_frame.info \
    -side left 




 ##########################################################################
#                                                                          #
#  event handler definitions (almost all are for '.draw_frame.c' )         #
#                                                                          # 
 ##########################################################################

################################ button 1 -> unselect and select
bind .draw_frame.c <1> "Button1_Pressed %x %y"
proc Button1_Pressed { x y } {
     Unselect
     if { [.draw_frame.c find withtag current] != ""} {
     
               # modify coordintates for viewed area: 
          set wx [ winfo pointerx .draw_frame.c ]
          set wy [ winfo pointery .draw_frame.c ]
          
          set delta_x [expr [ .draw_frame.c canvasx  $wx ] - $wx]
          set delta_y [expr [ .draw_frame.c canvasy  $wy ] - $wy]
          
          set x [ expr $x + $delta_x ]
          set y [ expr $y + $delta_y ]
     
          Select [.draw_frame.c find closest $x $y ] 
          } 
     }



################################ Control-d or Delete -> delete selected items
bind . <Control-KeyPress-d> "Delete"
bind . <Any-KeyPress> "CheckDelete %A"
proc CheckDelete { a } {
     if { $a == "\004"  } Delete
     }
proc Delete {} {
     foreach i [.draw_frame.c find withtag selected_vertex] {
          set ts [ .draw_frame.c gettags $i ]    ; # all tags
          set v  [ extract_reference $ts ]
	  set incident_Edges [ GD_Incidents $v ]
	  foreach j $incident_Edges { GD_Del_Edge $j  }
          GD_Del_Vertex $v
          }
     foreach i [.draw_frame.c find withtag selected_edge] {
          set ts [ .draw_frame.c gettags $i ]    ; # all tags
          set e  [ extract_reference $ts ]
          GD_Del_Edge $e
          }
     Emit_status
     }



############################### debug info when entering or exiting
.draw_frame.c bind all <Any-Enter> "display_pointer"
proc display_pointer {} {
     set curr [.draw_frame.c find withtag current ]    ; #current pointed by mouse edge
     if { [.draw_frame.c find withtag current] != "" } {
          set ts [ .draw_frame.c gettags $curr ]    ; # all tags
          .debug_frame.info configure -state normal
          .debug_frame.info delete 0.0 end
          .debug_frame.info insert 0.0 $ts
          .debug_frame.info configure -state disabled
          }
     }
     
.draw_frame.c bind all <Any-Leave> "clear_info"
proc clear_info {} {
     .debug_frame.info configure -state normal
     .debug_frame.info delete 0.0 end
     .debug_frame.info configure -state disabled
     }


############################# center button  -> add an edge
bind .draw_frame.c <2> "addedge %x %y"
proc addedge { x y } {
      global auto_orient_inserted_edge
      set curr [.draw_frame.c find withtag current ]    ; #current vertex
      set sel [.draw_frame.c find withtag selected_vertex]  ; # selected veretexes
      if { $curr == "" || $sel == {}  } return
      if { [.draw_frame.c type $curr] != "oval" && [.draw_frame.c type $curr] != "text" } return
      set curr_tags   [ .draw_frame.c gettags $curr ]
      set v1          [ extract_reference $curr_tags ]
      
      foreach v2_sel $sel {
	   
	       set v2_tags    [ .draw_frame.c gettags $v2_sel ]
	       set v2         [ extract_reference $v2_tags ]

	       set the_edge   [ GD_Add_Edge $v1 $v2 ]
	       if { $auto_orient_inserted_edge == "on" } {
	            GD_Orientation set $the_edge $v1
	            }
	       }
      Unselect
      Emit_status
      }


################################################ right button: add a vertex
set progressive_vertex_number 1

bind .draw_frame.c <3> "add_vertex %x %y"
proc add_vertex { x y } {
      global progressive_vertex_number
      
           # modify coordintates for viewed area: 
	   # it is very inefficient due to a lot of calculus during move
      set wx [ winfo pointerx .draw_frame.c ]
      set wy [ winfo pointery .draw_frame.c ]
      
      set delta_x [expr [ .draw_frame.c canvasx  $wx ] - $wx]
      set delta_y [expr [ .draw_frame.c canvasy  $wy ] - $wy]
      
      set x [ expr $x + $delta_x ]
      set y [ expr $y + $delta_y ]


      set v [GD_Add_Vertex $x $y]
      GD_SetLabel $v $progressive_vertex_number
      incr progressive_vertex_number
      Emit_status
      return $v
      }

################################ begin drag and dragging
bind .draw_frame.c <B1-Motion> "itemDrag %x %y"
set is_dragging {}   ; # list of the 'id' items (vertex) we are dragging
set drag_shadow {}   ; # 'id' of temporary item that represent the real item while dragging
proc itemDrag {x y} {
      global is_dragging drag_shadow
      
           # modify coordintates for viewed area: 
      set wx [ winfo pointerx .draw_frame.c ]
      set wy [ winfo pointery .draw_frame.c ]
      
      set delta_x [expr [ .draw_frame.c canvasx  $wx ] - $wx]
      set delta_y [expr [ .draw_frame.c canvasy  $wy ] - $wy]
      
      set x [ expr $x + $delta_x ]
      set y [ expr $y + $delta_y ]
      
      if { $is_dragging == {} } {
           set curr [.draw_frame.c find withtag current ]    ; #current vertex
           if { $curr == {} } return ;
	   if { [.draw_frame.c type $curr] != "oval" } {
	       if { [.draw_frame.c type $curr] != "text" } {
	           return 
	       } else {
	           set vert [extract_reference [.draw_frame.c gettags $curr] ]
	           set curr [.draw_frame.c find withtag r_v$vert]
	           }
	      }
	    
	   set is_dragging $curr
	   set drag_shadow [ .draw_frame.c create oval [expr $x-8] [expr $y-8] [expr $x+8] [expr $y+8] ]
      } else {
           .draw_frame.c coords $drag_shadow [expr $x-8] [expr $y-8] [expr $x+8] [expr $y+8]
           }
      } 


################################ end drag (drop)
bind .draw_frame.c <ButtonRelease-1> "B1_Release"
proc B1_Release {} {
      global is_dragging drag_shadow
      if { $drag_shadow!={} } {
      
          set coords [ .draw_frame.c coords $drag_shadow ] ;   # compute new coordintates
          set x  [ expr  [ lindex $coords 0 ]+8 ] 
          set y  [ expr  [ lindex $coords 1 ]+8 ]
	  
          .draw_frame.c delete $drag_shadow
	  
	  set ts [ .draw_frame.c gettags $is_dragging ]   ; # actual reposition 
	  set v [ extract_reference $ts ]
	  GD_Polygonal position_vertex $v $x $y
	  
          set drag_shadow {}   ; # reset drag-and-drop status
	  set is_dragging {}
	  }
      }



############################# <s>, <d>, <f>  change the orientation of a selected edge
bind . <s> { 
     foreach i [.draw_frame.c find withtag selected_edge] {
          set ts [ .draw_frame.c gettags $i ]    ; # all tags
	  set e  [ extract_reference $ts ]   ; # extact reference for GD command
          set extremes  [GD_Extremes $e]     ; #list of extremes (length 2)
	  set v1 [lindex $extremes 0]        
	  GD_Orientation set $e $v1
          Select [.draw_frame.c find withtag "r_e$e" ]
          Emit_status
	  }
     }
bind . <d> { 
     foreach i [.draw_frame.c find withtag selected_edge] {
          set ts [ .draw_frame.c gettags $i ]    ; # all tags
	  set e  [ extract_reference $ts ]   ; # extact reference for GD command
          set extremes  [GD_Extremes $e]     ; #list of extremes (length 2)
	  set v2 [lindex $extremes 1]
	  GD_Orientation set $e $v2
          Select [.draw_frame.c find withtag "r_e$e" ] 
          Emit_status
	  }
     }
bind . <f> {
     foreach i [.draw_frame.c find withtag selected_edge] {
          set ts [ .draw_frame.c gettags $i ]    ; # all tags
	  set e  [ extract_reference $ts ]   ; # extact reference for GD command
          set extremes  [GD_Extremes $e]     ; #list of extremes (length 2)
	  GD_Orientation unset $e 
          Select [.draw_frame.c find withtag "r_e$e" ]
	  Emit_status
	  }
     }

    






# =========================================================================
# =========================================================== utility

proc itemStartDrag {c x y} {
      global lastX lastY
      set lastX [$c canvasx $x]
      set lastY [$c canvasy $y]
      } 
	    
proc Emit_status {}   {
       catch {
             set point_visualized [.info_frame.t index @0,0]   ;# save a point of text that is visualized
             .info_frame.t configure -state normal
             .info_frame.t delete 0.0 end
             .info_frame.t insert 0.0 [GD_State]
             .info_frame.t yview $point_visualized   ;# move window to the point saved 
             .info_frame.t configure -state disabled
             }
       }


proc Select { id } {
      set t [.draw_frame.c type $id ] 
      if { $t == "oval" } {
            .draw_frame.c addtag selected_vertex withtag $id
            .draw_frame.c itemconfigure $id  -outline red  -width 2
          } elseif { $t == "line" } {
            .draw_frame.c addtag selected_edge withtag $id
            .draw_frame.c itemconfigure $id  -fill red
	  } elseif { $t == "text" } {
	    set vert [extract_reference [.draw_frame.c gettags $id] ]
            .draw_frame.c addtag selected_vertex withtag r_v$vert
            .draw_frame.c itemconfigure  r_v$vert  -outline red  -width 2
	  }
      }
      
proc Unselect { } {
              # unselect vertices
      .draw_frame.c itemconfigure selected_vertex -outline black -width 1
      .draw_frame.c dtag selected_vertex
              # unselect edges
      .draw_frame.c itemconfigure selected_edge -fill black 
      .draw_frame.c dtag selected_edge
      }



# return the first element of the list beginning with "r_"
#    in this application "r_v0x00000" is a reference (pointer) to a vertex
#    in this application "r_e0x00000" is a reference (pointer) to an edge
#    in this application "r_t0x00000" is a reference (pointer) to a vertex but the widget is a text label for that vertex
# the returned string is the pointer value "0x00000"

proc extract_reference { t } {
      foreach x $t {
          if { [ string range $x 0 1 ] == "r_" } {
              return [ string range $x 3 end ]
	      }
          }
      }






wm title . "demo application"
wm geometry . 500x500+20+80 ;# set initial geometry for main window
.menu.window.m invoke 1   ;# create info window
wm geometry .info_frame +700+10  ;# set initial geometry for info window
Emit_status   ;# update info window
Update_radios  ;# create the panel_frame

puts "Tcl script loaded."  ;# notify user that  everything is ok




####################################### debug state initialization
.menu.orientation.m invoke 1 ;# new orientation setted as current
.menu.orientation.m invoke 6 ;# cyclicity info on it
.menu.orientation.m invoke 7 ;# auto orientation of edges 


#set v1 [add_vertex 40 40]
#set v2 [add_vertex 90 40]
#set v3 [add_vertex 40 90]
#set the_edge   [ GD_Add_Edge $v1 $v2 ]
#GD_Orientation set $the_edge $v2
#GD_Oriented_Cycles_Info; Emit_status
#GD_Layering sugituning_clear; Emit_status

puts "Debug initialization finished"  ;# notify user that  everything is ok







































########################################
#                                      #
#            garbage!!!                #
#                                      #
########################################

#menubutton .menu.debug -text "Debug"       -menu .menu.debug.m -underline 0
#pack       .menu.debug -side left -padx 2m -pady 1m
#menu    .menu.debug.m
#        .menu.debug.m add command -label "User (autonumbering)"  -underline 0 -command { GD_Show_Label user }
#        .menu.debug.m add command -label "In_Degree"  -underline 0 -command { GD_Show_Label in_degree }
#        .menu.debug.m add command -label "Out_Degree" -underline 0 -command { GD_Show_Label out_degree }


#menubutton .menu.draw -text "Draw"     -menu .menu.draw.m -underline 0
#pack       .menu.draw -side left -padx 2m -pady 1m
#menu    .menu.draw.m
#        .menu.draw.m add command -label "Random"  -underline 0 -command "GD_Polygonal random; Emit_status"
#        .menu.draw.m add separator
#        .menu.draw.m add command -label "Simple"  -underline 0 -command "GD_Layering none; Emit_status"
#        .menu.draw.m add command -label "Proper"  -underline 0 -command "GD_Layering proper; Emit_status"
#        .menu.draw.m add command -label "Sugiyama"  -underline 1 -command "GD_Layering sugiyama; Emit_status"
#        .menu.draw.m add command -label "Sugiyama & Clean"  -underline 1 -command "GD_Layering sugiyama_clean; Emit_status"
#        .menu.draw.m add command -label "SugiTuning"  -underline 4 -command "GD_Layering sugituning; Emit_status"
#        .menu.draw.m add command -label "SugiTuning & Clean"  -underline 5 -command "GD_Layering sugituning_clear; Emit_status"




