#ifndef __ECO_H__
#define __ECO_H__

___ECO_C++_sign___

#include <stdarg.h>
#include <iostream.h>
class ECO_exception 
    {
    friend ostream& operator<< ( ostream& os, const ECO_exception& e);
    private:
       const char* which; 
    public:
       static const char  Cannot_register []="Cannot_register" ;     
       static const char  Attempted_deallocation_of_extended_object []="Attempted_deallocation_of_extended_object" ; 
       static const char  Attempted_unextend_of_unregistred_extender []="Attempted_unextend_of_unregistred_extender" ;
       static const char  Internal_wrong_precompilde_code_non_extensible []= "Internal: wrong_precompilde_code_non_extensible";
       ECO_exception(const char * x): which(x) {};
    };

inline ostream& operator<< ( ostream& os, const ECO_exception& e)
    { os << e.which;  };

class No_IExtender: public ECO_exception
    {
    private:
       static const char  No_IExt_string[]="No instance of extender with specified owner";
    public:
       No_IExtender(): ECO_exception(No_IExt_string) {}
    };



// ============================================= extender class registration system
typedef short extender_id; 

class ECO_registration_client1
    {
    public:
       extender_id id;
    };

template <class T>
class ECO_registration_client: public ECO_registration_client1
    {
    public:
       ECO_registration_client()
           {
	   // cout << "ECO_registration_client::ECO_registration_client()" << endl;
	   id= T::sr.obtain_registration();
	   }
    };

class debug
    {
    public:
       virtual void out_debug(ostream& os=cout) const 
             { os << "<no debug output>" << endl; }
       virtual void out_debug2()const 
             { out_debug(cout); }
    };

 

class ECO_registration
    {
    friend ostream& operator<< ( ostream& os, const ECO_registration& e);
    private:
        bool registration_allowed;
        extender_id next_registration_number;
    public:
        extender_id get_next() 
                 { return next_registration_number; }
        bool can_register()
                 { return registration_allowed; }
		 
        extender_id obtain_registration()                
                 {
		 if ( can_register() )
		     return next_registration_number++;
		 else
		     throw ECO_exception(ECO_exception::Cannot_register);
		 };
        void  end_registrations()
                 { registration_allowed=false; }
        ECO_registration() 
                 {
		 //cout << "ECO_registration::ECO_registration()" << endl;
		 next_registration_number=0;
		 registration_allowed=true;
		 };
    };
inline ostream& operator<< ( ostream& os, const ECO_registration& e)
    { 
    os << e.registration_allowed << ' ' <<  e.next_registration_number << endl;;
    };

#define call_extender_method(E, M ) \
      {\
      for( int __x_i_x__=0; __x_i_x__<sr.get_next(); __x_i_x__++ )    \
          for( E::Extender (** __x_j_x__)= &(extender_table()[__x_i_x__]) ; *__x_j_x__ != (void*)0; __x_j_x__=&(*__x_j_x__)->next_instance() )\
             (*__x_j_x__)->M;\
      }

#define find_trailer(Trailer_Class, ptr_to_Tow_instance ) \
     	 ( (Trailer_Class*) ((ptr_to_Tow_instance)->find_IExtender(this, Trailer_Class::registration_id.id) ) )




class __Extensible;
class __ECO_class: public debug
      {
      private:
           typedef void * VoidPtr;
           __ECO_class(const __ECO_class& );    // no copy constructor
           __ECO_class& operator= (const __ECO_class& ); // no copy 
      protected:
           __ECO_class():
                extender_table_size(0),
                extender_table( NULL ),
	        CastUp(NULL)
	        {}
           ~__ECO_class()
	        { delete extender_table; }
           VoidPtr * extender_table;
      public:
           unsigned extender_table_size;   // size of the extender table
           __Extensible* CastUp;   //  Cust Up from virtual base class
      };



class Generic_Extender: virtual public __ECO_class
        {
	protected:
            Generic_Extender*         next_instance1;
        public:
            ECO_registration_client1& id;    // this is a reference to the static registration
            __Extensible&             extended;
            bool                      is_dynamic;
            void*                     owner;
	    Generic_Extender*& next_instance() { return next_instance1; }
            Generic_Extender(__Extensible& g, ECO_registration_client1& id1, bool f );
            virtual ~Generic_Extender();
        };

class __Extensible: virtual public __ECO_class
      {
      protected:
           typedef Generic_Extender* ExtenderPtr;
           ExtenderPtr* extender_table1() const
	            { return (ExtenderPtr*) __ECO_class::extender_table; }
      protected:
           
           __Extensible( unsigned ets)
	        {
		CastUp=this; // prepare for successive Cust Up from virtual base class
                extender_table_size=ets;
		(ExtenderPtr*)__ECO_class::extender_table=new ExtenderPtr[ets];
                for( int i=0; i< extender_table_size; i++ )    // initialize extender table
		       extender_table1()[i] = NULL;
		}
           ~__Extensible() 
	        {
		}
      public:
           void __link_extender   (ExtenderPtr x, const ECO_registration_client1& id )
                {
		ExtenderPtr p=extender_table1()[id.id];
                x->next_instance()= p;
                extender_table1()[id.id]= x;
                }
           void __unlink_extender (ExtenderPtr x, const ECO_registration_client1& id )
                {
                ExtenderPtr* j;
                for( j= &(extender_table1()[id.id]) ;
                     (*j) !=  NULL;
                     j=&(*j)->next_instance() )
                if( *j==x )
                          {
                          *j= x->next_instance();
                          x->next_instance()= NULL;
                          return;
                          }
                throw ECO_exception(ECO_exception::Attempted_unextend_of_unregistred_extender);
                }
           ExtenderPtr find_IExtender( const void* owner, extender_id exid )
                      {
                      for( ExtenderPtr* j= &(extender_table1()[exid]) ; *j != NULL; j=&(*j)->next_instance() )
                         if ( (*j)->owner==owner )  return *j;
                      return ((ExtenderPtr)NULL) ;
                      }
           
           ExtenderPtr __deep_get_IExtenderPtr( int hm, ... ) const
	        {
	        va_list AP;
	        va_start( AP, hm);
	        ExtenderPtr* current_table= extender_table1();
		ExtenderPtr p;
		
	        for( int i=1; i<=hm; ++i )
                   {
	           unsigned index= va_arg( AP, unsigned );
		   p= current_table[index];
		   if (!p) return NULL;
		   if (i != hm )   // if it is not the last
		        {
		        __Extensible* ep= p->CastUp;
		        if (!ep )
		           throw ECO_exception(ECO_exception::Internal_wrong_precompilde_code_non_extensible);
		        current_table= ep->extender_table1();
			}
	           }
	        va_end(AP);
		return p;
	        }
	    
      };

                  inline
Generic_Extender::
Generic_Extender(__Extensible& g, ECO_registration_client1& id1, bool f ):
                  extended(g),
                  id(id1),
                  is_dynamic( f ),
                  owner( (void*)0 )
                  { 
		  g.__link_extender(this, id1); 
		  }


                  inline
Generic_Extender::
~Generic_Extender()
                  { 
		  extended.__unlink_extender(this, id ); 
		  }

#endif
