
// ============================
// MS: Minimal Structure
//     interface with STL

#include <list.h>
#include <algo.h>
struct MS_linear {};
struct MS_log {};

template <class T>
class MS_MSet
    {
    list<T> L;
    typedef list<T>::iterator SubIter;
    typedef list<T>::const_iterator ConstSubIter;
    unsigned active_visit;
    public:
       class iterator 
                {
		friend MS_MSet;
		    iterator(const SubIter& it, MS_MSet<T>* w):
		       i(it),
		       valid(true),
		       The_Set(w)
		       {}
                    bool valid;
		    SubIter i;
		    MS_MSet<T>* The_Set;
		public:
		    iterator( const iterator&i ):   
		        valid(i.valid),
		        i(i.i),
		        The_Set(i.The_Set)
		        { ++The_Set->active_visit; }   // ogni costuzione una nuova visita iniziata
                    bool EndVisit()   // true when visit is finished  
                        {
		        if ( !valid ) return true;
		        if ( i==The_Set->L.end() )
		            {
		            valid= false;
		            --The_Set->active_visit;
		            return true;
		            }
		        else
		            return false;
		        }   
                    void another()
		        { ++i; }
		    void invalidate() 
		        { valid=false; The_Set->active_visit--;}
                };

       MS_MSet():  active_visit(0) {}
       unsigned size() const { return L.size(); }
       void insert(T x) 
                {
	        if (active_visit) throw "MS_MSet: insert with active visit";
                L.push_back(x); 
	        } 
       bool erase(T x)  
                {
	        if (active_visit) throw "MS_MSet: erase with active visit";
                SubIter i= find( L.begin(), L.end(), x);
		if ( i== L.end() ) 
		     return false;
		else 
		     {
		     L.erase(i);
		     return true;
		     }
		}
       iterator BeginVisit() const
                {
		SubIter I= ((MS_MSet<T>*)this)->L.begin();
		return iterator(I, (MS_MSet<T>*)this);   // return a valid iterator
		}
       T operator[] (const iterator& i ) 
                {
		if (!i.valid || i.The_Set!=this) throw "MS_MSet: invalid iterator";
		return *(i.i);
		}
    };


