
#include <iostream.h>
#include <strstream.h>
#include "entity.h"



         void
Null_Token_Buffer::
add_token( const A_token& )
         {}

         A_token 
Null_Token_Buffer::
inner_lexer()        // this method is called just at the initialization of the 'w' (the window on the stream of token)
         {
	 A_token t; 
	 t.tokenid= '\0'; // this value is not important
	 return t;      
	 }


         void 
spaces( ostream &os, int indent )
         {
	 for( int i=0; i<indent; i++ )
	   os << ' ';
	 };

Null_Token_Buffer::
Null_Token_Buffer(): 
         Token_Buffer(*(Scope*)NULL) 
         {}


Token_Buffer::
Token_Buffer(Scope& sc): 
         Token_Source(sc) 
         {}


//===========================================================
const char* Get_Operator_Name(Operator_ID op)
        {
	const char* p;
	switch(op)
	    {
            case Op_None: p="None"; break;
	    case Mul: p="*"; break;
	    case Div: p="/"; break;	        
	    case Mod: p="%"; break;	        
	    case Sum: p="+"; break;	        
	    case Sub: p="-"; break;	        
	    case Bit_And: p="&"; break;     
	    case Bit_Or: p="|"; break;      
	    case Bit_Xor: p="^"; break;     
	    case Bit_Not: p="~"; break;     
	    case Comma: p=","; break;       
	    case Less_Equal: p="<="; break;  
	    case Greater_Equal: p=">="; break; 
	    case Less: p="<"; break;        
	    case Greater: p=">"; break;     
	    case Equal: p="=="; break;       
	    case Not_Equal: p="!="; break;   
	    case Sum_Assign: p="+="; break;  
	    case Sub_Assign: p="-="; break;  
	    case Mul_Assign: p="*="; break;  
	    case Div_Assign: p="/="; break;  
	    case Mod_Assign: p="%="; break;  
	    case Bit_Xor_Assign: p="^="; break; 
	    case Bit_And_Assign: p="&="; break; 
	    case Bit_Or_Assign: p="|="; break;  
	    case RShift_Assign: p=">>="; break;  
	    case LShift_Assign: p="<<="; break;  
	    case Assign: p="="; break;         
	    case RShift: p=">>"; break;         
	    case LShift: p="<<"; break;         
	    case PlusPlus: p="++"; break;       
	    case MinusMinus: p="--"; break;     
	    case Logic_And: p="&&"; break;      
	    case Logic_Or: p="||"; break;       
	    case Logic_Not: p="!"; break;      
	    case Question_Colon: p="?:"; break; 
	    case MinMax: p="Min-Max"; break;     // WARNING: forse e` meglio toglierlo!
	    case Pointsat: p="->"; break;       
	    case Pointsat_Star: p="->*"; break;  
	    case Call: p="()"; break;           
	    case Array_deref: p="[]"; break;
	    case New: p="new"; break;            
	    case Delete: p="delete"; break;         
	    case New_Array: p="new[]"; break;      // WARNING: per gli array, new e delete sono considerati diversi ???
	    case Delete_Array: p="delete[]"; break;
	    default: p="<<internal incoerece>>"; break;
	    }
	return p;
	};

//=====================================================================


       bool
Operator_Identifier::
operator==( const Operator_Identifier& oi ) const
	            {
		    if ( k!= oi.k ) return false;
		    switch( k )
		        {
		        case conversion:
			    if ( !t || !oi.t )
				 M::hl_internal(M::fatal, "internal error Operator_Identifier::operator==(), incoherent type");
			    return t->is_equal(oi.t);
			    break;
		        case proper_operator:   return id==oi.id;
			case null:              return true;
		        default:
			    M::hl_internal(M::fatal, "internal error Operator_Identifier::operator==(), incoherent operator code");
			    break;
		        }
		    return false;// this statement won't be executed 
                    }


ostream& operator << ( ostream& os, const Operator_Identifier& Id)
        {
	os << "operator";
	switch( Id.k )
	      {
	      case Operator_Identifier::null :
	           os << "<null>";
	           break;
	      case Operator_Identifier::conversion :
	           os << " "; Id.t->output(os);
	           break;
	      case Operator_Identifier::proper_operator :
	           os << Get_Operator_Name(Id.id);
	           break;
	      }
	return os;
	};

ostream& operator << ( ostream& os, const  Entity_Name& n)
        {
	switch( n.k )
	     {
	     case Entity_Name::none:
	          os << "<unnamed>";
	          break;
	     case Entity_Name::constructor:
	          os << "<constructor>";
	          break;
	     case Entity_Name::destructor:
	          os << "<destructor>";
	          break;
	     case Entity_Name::oper:
	          os <<  n.op_id;
	          break;
	     case Entity_Name::string:  
	          os << n.str;
	          break;
	     case Entity_Name::template_instance:
	          os << n.Templ->name << "< ";
	          for( list<Type*>::iterator i= n.parameters->begin(); i!= n.parameters->end(); i++ )
	              {
		      if (i!=n.parameters->begin()) os << ", ";
		      (*i)->output(os);
		      }
	          os << " >";
	          break;
	     default:
	          M::hl_internal(M::fatal, "operator << ( ostream& os, Entity_Name& n)" );
	          os << "internal error";
	          break;
             }	
	return os;
	};

        void
Entity_Name::
check_consistency() const
        {
	switch( k )
	    {
	    case string: 
	        if (!str) goto error;
	        break;
	    case template_instance:
	        if (Templ->cl!= Entity::Template ) goto error;
	        if ( parameters->size() <1 ) goto error;
	        break;
	    case destructor:
	        if (!str) goto error;
	        break;
	    case oper:
	        /* op_id.check_consistency(); */ 
	        break;
	    case constructor:
	    case none: 
	        break;
	    default:
	        goto error;
	        break;
	    }
	return;
	error:
	   cout << "Entity_Name incosistente" << endl;
	   exit (EXIT_FAILURE);
	}

        bool
Entity_Name::
operator==( const Entity_Name& en ) const
	{
	if ( k!= en.k ) return false;
	switch( k )
	    {
	    case string:  
		     return (str==en.str || (0==strcmp(str, en.str)) );
	    case oper:   
		     return op_id==en.op_id;
	    case template_instance:
	             {
		     if (Templ!= en.Templ) return false;
	             list<Type*>::iterator j,i;
		     for(  j= parameters->begin(), i=en.parameters->begin();
			   j!= parameters->end(), i!= en.parameters->end();
			   j++, i++ )
		          if ( ! (*j)->is_equal(*i) ) return false;
		     return true;
		     }
	    case constructor:
	    case destructor:
	    case none:   
		     return true;
	    default:
	          M::hl_internal(M::fatal, "Entity_Name::operator==(const Entity_Name&) incoherent type" );
	          break;
	    }
	
	return false;
	};


        
//=====================================================================

Entity_Container::
Entity_Container(const char *n, Entity_Class c):
         Entity(n, c)
         {};

Entity_Container::
Entity_Container(const Entity_Name &n, Entity_Class c):
         Entity(n, c)
         {};

Entity_Container::
~Entity_Container()
         {}

         void 
Entity_Container::
local_output(ostream &os, int indent) const
         {
         simple_output(os, indent);
	 };


         void 
Entity_Container::
scope_output(ostream &os, int indent) const
         {
         local_output(os, indent);
	 os << endl << "------ descend level" << endl;
	 if (get_container()) get_container()->scope_output(os, indent);
	 };


         void 
Entity_Container::
deep_output(ostream &os, int indent) const
         {
         simple_output(os, indent);
	 };


         Entity* 
Entity_Container::
Scope_Name_LookUp(const Entity_Name& op) const // search in the owner, too.
         {
	 Entity* x=Local_Name_LookUp(op);
	 if (!x ) x= Local_Name_LookUp_aggregate(op);
	 if (!x && get_container())
	    x= get_container()->Scope_Name_LookUp(op);
	 return x;
	 };

         AggregateType_Entity*
Entity_Container::
Scope_Name_LookUp_aggregate(const Entity_Name& op) const // search in the owner, too.
         {
	 AggregateType_Entity* x=Local_Name_LookUp_aggregate(op);
	 if (!x && get_container())
	    x= get_container()->Scope_Name_LookUp_aggregate(op);
	 return x;
	 };

         Entity* 
Entity_Container::
Local_Name_LookUp(const Entity_Name& op) const 
         {
	 return NULL;
	 }

         AggregateType_Entity* 
Entity_Container::
Local_Name_LookUp_aggregate(const Entity_Name& op) const 
         {
	 return NULL;
	 }

//=====================================================================
         void 
Extender_Methods_Container_Entity::
deep_output(ostream &os, int indent) const
         {
	 spaces(os, indent);
	 os << "Extender Methods: " << endl;
	 for( ElemIter i= Elements.begin(); i!= Elements.end(); i++ )
	      (*i)->deep_output(os, indent+5);
	 };

         void 
Extender_Methods_Container_Entity::
C_output(ostream &os, int indent) const
         {
	 for( ElemIter i= Elements.begin(); i!= Elements.end(); i++ )
	      switch( (*i)->cl )
	          {
		  case Entity::Overloadable :
		       {
		       Overloadable_Entity& ov= *(Overloadable_Entity*)(*i);
		       list<Particular_overloadable*>::const_iterator j;
		       for( j=ov.functions.begin(); j!=ov.functions.end(); j++ )
			   {
			   spaces(os,indent);
			   os << "virtual ";
			   (*j)->T->inner_type->get_inner()->out_Elementary(os);
                           os << " " << ov.name << "(";
			   (*j)->T->Parameters.one_line_local_output(os);
			   os << ") {};" << endl;
			   }
		       }
		       break;
		  case Entity::Function_E :
		  default:
	               M::hl_internal(M::fatal, "Extender_Methods_Container_Entity::C_output(ostream &os, int indent) incoherent data" );
		       break;
		  }
 	 }

//=====================================================================
Grouping_Entity::
Grouping_Entity(const char *n, Entity_Class c):
         Entity_Container(n, c)
         {};

Grouping_Entity::
Grouping_Entity(const Entity_Name &n, Entity_Class c):
         Entity_Container(n, c)
         {};

         void 
Grouping_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent); 
	 const char* n;
	 os << "Grouping " << name  << endl;
	 };

         void 
Grouping_Entity::
deep_output(ostream &os, int indent) const
         {
         simple_output(os, indent);
	 for( ElemIter i= Elements.begin(); i!= Elements.end(); i++ )
	      (*i)->deep_output(os, indent+4);
	 };

         void 
Grouping_Entity::
local_output(ostream &os, int indent) const
         {
         simple_output(os, indent);
	 for( ElemIter i= Elements.begin(); i!= Elements.end(); i++ )
	      (*i)->simple_output(os, indent+4);
	 };


   





         Entity* 
Grouping_Entity::
Local_Name_LookUp(const Entity_Name& en) const // exclude AggregateType
         {
         if ( en.k== Entity_Name::none ) 
	      {
	      M::hl_internal(M::rec, "Grouping_Entity::Local_Name_LookUp(Entity_Name& en): no name to search for" );
	      return NULL;
	      }

	 Entity* x=NULL;
	 
	 Simple_Entity* q=new Simple_Entity(Entity_Name(en),None_SCSPEC,NULL);   // value to search
	 pair<ElemIter,ElemIter> p= Elements.equal_range(q);
	 delete q;
	 
	 unsigned match=0;
	 for(ElemIter i= p.first; i!=p.second; i++)
	    if ( (*i)->cl!=AggregateType && (*i)->name == en)
               {
	       ++match;
               x=*i;
	       }
	 // if (match>1) { cerr << "warning non aggregate match=" << match << " on " << en << endl; }
	 if ( !x ) 
	       {
	       list<Entity_Container*>::const_iterator i;
	       for( i=auxilary_search_spaces.begin(); i!= auxilary_search_spaces.end(); ++i)
		   if( x= (*i)->Local_Name_LookUp(en) ) break;
	       }
	 return x;     
	 };



         AggregateType_Entity* 
Grouping_Entity::
Local_Name_LookUp_aggregate(const Entity_Name& en) const
         {
         if ( en.k== Entity_Name::none ) 
	      {
	      M::hl_internal(M::rec, "Grouping_Entity::Local_Name_LookUp_aggregate(Entity_Name& en): no name to search for" );
	      return NULL;
	      }
	 AggregateType_Entity* x=NULL;
	 Simple_Entity* q= new Simple_Entity(Entity_Name(en),None_SCSPEC,NULL);   // value to search
	 pair<ElemIter,ElemIter> p= Elements.equal_range(q);
	 delete q;
	 unsigned match=0;
	 for(ElemIter i= p.first; i!=p.second; i++)
	    if ( (*i)->cl==AggregateType && en==(*i)->name )
               {
	       ++match;
               x=(AggregateType_Entity*)*i;    // get the last
	       }
	 //if (match>1) { cerr << "warning aggregate match=" << match << " on " << en << endl; }
	 if ( !x ) 
	       {
	       list<Entity_Container*>::const_iterator i;
	       for( i=auxilary_search_spaces.begin(); i!= auxilary_search_spaces.end(); ++i)
		   if( x= (*i)->Local_Name_LookUp_aggregate(en) ) break;
	       }
	 return x;     
	 };






         Entity& 
Grouping_Entity::
add_Entity( Entity* e )
             { 
	     if ( !e )
	         {
	         M::hl_internal(M::rec, "Grouping_Entity::add_Entity( Entity* e ): null value passed" );
                 return *(Entity*)NULL;		 
		 }
	     
	     e->name.check_consistency();
	     Elements.insert( e );
	     e->set_container( this );
	     return *e;
	     }

             bool
Grouping_Entity::compare::
operator()(Entity* x, Entity* y) const
             {
	     return x->name < y->name;
	     }


             void
Grouping_Entity::
change_name( Entity* e, const Entity_Name& n)
             {
	     if (!e)
	         {
	         M::hl_internal(M::rec, "Grouping_Entity::change_name( Entity* e, const Entity_Name& n) null value passed" );
		 return;
		 }
	     Elements.erase(e);
	     e->name=n;
	     Elements.insert(e);
	     }




             bool
Operator_Identifier::
operator<(const Operator_Identifier& op ) const
             {
	     if (k==op.k)
	        switch( k )
	            {
		    case conversion: 
		       return false;       // all conversion are equal
		      
		       /*
		       if (t->is_equal(op.t)) // WARNING: this is to avoid ordering on types
		          return false;	      // but I don't investigate if it always work  
		       else
		          return t<op.t; */
		      
		      
		       break;                    
		    case proper_operator:	
		       return id < op.id; break;
		    case null:
		       return false; break;     // all null are equal
		    default:
	               M::hl_internal(M::fatal, "Operator_Identifier::operator<() incoherent value passed" );
		       return false;
		    }
	     else
	        return k < op.k;
	     }

             bool
Entity_Name::
operator<(const Entity_Name& y ) const
             {
	     if ( k == y.k )  // classe uguale
	         switch( k )
	            {
		    case string:
		         return strcmp(Get_str(), y.Get_str())<0; break;
		    case constructor:
		    case destructor:     // all constructor and destructor  are equal
		    case none:          
		         return false; break;
		    
		    case template_instance:
		         if( Get_Template()==y.Get_Template() )
		             return false;    //instance of the same template are equal
		         else
		             return Get_Template()->name < y.Get_Template()->name;
		         break;
		    case oper:
		         return Get_op() < y.Get_op();
		    default:
	               M::hl_internal(M::fatal, "Entity_Name::operator<() incoherent value passed" );
		       return false;
		       break;
		    }
	     else
	         return k < y.k;
	     }

// ===========================================================
         void 
Function_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent);
	 os << name << " function ";
	 if (T)
  	    T->output(os);
	 else
	    os << "<unknown>";
	 os <<endl;
         };


void 
Function_Entity::
deep_output(ostream &os, int indent) const
         {
	 local_output(os, indent);
         Get_local().deep_output(os, indent+5);	 
         };

// =====================================================

         void
Template_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent);
	 os << name << " template #=" << Elements.size() 
	    << " buffer_size=" << buffer.size() << " <";
	 p.one_line_local_output(os);
	 os << " >" << endl;
         };


Template_Entity::
Template_Entity(Scope& sc):
         Grouping_Entity(NULL, Template),
         p( *new Parameters_Entity ),
         buffer(sc)
         {
	 p.set_container(this);
	 };
	 
Template_Entity::
~Template_Entity()
         {
         delete &p;
	 };

         Entity* 
Template_Entity::
Local_Name_LookUp(const Entity_Name& en) const // exclude AggregateType
         {
         if ( en.k== Entity_Name::none ) 
	      M::internal( "Template_Entity::Local_Name_LookUp(Entity_Name& en)" );
	 
	 Entity* x=NULL;
	 Parameters_Entity::ElemIter i;
         for( i=p.Elements.begin(); i!=p.Elements.end(); ++i )
	     if ( en== (*i)->name && (*i)->cl!=AggregateType ) x=*i;
	 
	 if (!x) x= Grouping_Entity::Local_Name_LookUp(en);
	 return x;     
	 };



         AggregateType_Entity* 
Template_Entity::
Local_Name_LookUp_aggregate(const Entity_Name& en) const
         {
         if ( en.k== Entity_Name::none ) 
	      M::internal(" Template_Entity::Local_Name_LookUp(Entity_Name& en)" );
	 AggregateType_Entity* x=NULL;
	 
	 Parameters_Entity::ElemIter i;
         for( i=p.Elements.begin(); i!=p.Elements.end(); ++i )
	     if ( en== (*i)->name && (*i)->cl==AggregateType ) x=(AggregateType_Entity*) *i;
	 
	 if (!x) x= Grouping_Entity::Local_Name_LookUp_aggregate(en);
	 
	 return x;     
	 };

// =====================================================

         void 
Overloadable_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent);
	 os << name << " overloadable"<< endl; 
	 };

         void 
Overloadable_Entity::
deep_output(ostream &os, int indent) const
         {
	 simple_output(os,indent);
	 for( list<Particular_overloadable *>::const_iterator i= functions.begin(); i!= functions.end(); i++ )
	     {
             (*i)->deep_output(os, indent+5);
	     os << endl;
	     }
	 };

         Particular_overloadable& 
Overloadable_Entity::
add_Function( Function * t )
         {
	 Particular_overloadable* f=new Particular_overloadable(t, this);
         functions.push_back(f);
	 return *f;
	 }


// =====================================================


         void
Parameters_Entity::
one_line_local_output(ostream &os) const
         {
	 static progr=0;
	 for( list<Entity*>::const_iterator i= Elements.begin(); i!= Elements.end(); i++ )
	      {
	      if (i!=Elements.begin() ) os << ", ";
	      if ( (*i)->cl==Simple )
		  {
		  Simple_Entity& se= *(Simple_Entity*)(*i);
	          Type* t=se.Get_Type();
                  ostrstream par;
		  par << "p" << progr++ << ends;
	          if (t) t->output(os, par.str() ); else os << "<unknown>" << endl;
		  delete par.str();
		  }
	      else if ( (*i)->cl==AggregateType )
		  {
		  os << (*i)->name;
		  }
	      }
	 };



         Entity& 
Parameters_Entity::
add_Entity( Entity* e ) 
         { 
	 Elements.push_back(e);
	 e->set_container(this);
	 return ** --Elements.end();
	 }


// =====================================================

         void 
Particular_overloadable::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent); 
         T->output(os);
	 };

         void 
Particular_overloadable::
deep_output(ostream &os, int indent) const
         {
	 local_output(os, indent); os << endl;
         Get_local().deep_output(os, indent+5);	 
         };

         AggregateType_Entity*
Particular_overloadable::
Local_Name_LookUp_aggregate(const Entity_Name& en) const 
         {
         if ( en.k== Entity_Name::none ) M::internal("Particular_overloadable::Local_Name_LookUp_aggregate(): name=NULL");
	 AggregateType_Entity* x=NULL;
	 
	 unsigned match=0;
	 Parameters_Entity::ElemIter i;
	 for( i=T->Parameters.Elements.begin(); i!=T->Parameters.Elements.end(); i++)
	    if ( (*i)->cl==AggregateType && (*i)->name == en)
               {
	       ++match;
               x=(AggregateType_Entity*)*i;
	       }
	 // if (match>1) { cerr << "warning non aggregate match=" << match << " on " << en << endl; }
	 return x;     
	 }

         Entity* 
Particular_overloadable::
Local_Name_LookUp(const Entity_Name& en) const
         {
         if ( en.k== Entity_Name::none ) M::internal("Particular_overloadable::Local_Name_LookUp(): name=NULL");
	 Entity* x=NULL;

	 
	 unsigned match=0;
	 Parameters_Entity::ElemIter i;
	 for( i=T->Parameters.Elements.begin(); i!=T->Parameters.Elements.end(); i++)
	    if ( (*i)->cl!=AggregateType && (*i)->name == en)
               {
	       ++match;
               x=*i;
	       }
	 // if (match>1) { cerr << "warning non aggregate match=" << match << " on " << en << endl; }
	 return x;     
	 }

// =====================================================
         void 
Simple_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent); 
	 os << name << " Simple " << TheSC << ' ';
	 if (TheType)
	     TheType->output(os);
	 else
	     os<<  "unknown-type";
	 os << endl;
	 };

         Type* 
Simple_Entity::
Get_Type() const 
         { return TheType; }


EnumElement_Entity::
EnumElement_Entity(const char *n):
         Entity(n,EnumElement)
         {};

         void
EnumElement_Entity::
simple_output(ostream& os, int indent) const
         { spaces(os,indent); os << name << endl;; };  // name must be != NULL

// =================================================
         void 
AggregateType_Entity::
set_container( Entity_Container* ec)
         {
	 Grouping_Entity::set_container(ec);
	 Extender_Methods.set_container(ec); // Extender_Methods is in the same scope of AggregateType_Entity
	 }

         void 
AggregateType_Entity::
deep_output(ostream &os, int indent) const
         {
	 Grouping_Entity::deep_output(os, indent);
	 Extender_Methods.deep_output(os, indent+5);
	 }

         void 
AggregateType_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent);
	 os <<  name << ": ";
	 for ( list<AggregateType_Entity*>::const_iterator i= inheritance.begin(); i!=inheritance.end(); i++ )
             {
	     if ( i!= inheritance.begin() ) os << ", ";
	     os << (*i)->name;
	     }
	 if (extensible) os << "  /extensible";
	 if (extend) os << " /extend " << extend->name;
	 if (dynamic) os << " /dynamic " << dynamic->name;
	 os << " /AggregateType #=" << Elements.size()
            << " /aux_space #=" << auxilary_search_spaces.size() << endl;
	 };


         void 
AggregateType_Entity::
set_extensible()
         { extensible= true; };

         bool
AggregateType_Entity::
add_extend(AggregateType_Entity* x)
         {
	 if (extend || dynamic )
	     {
	     M::hl_internal( M::Mult_E_or_D );
	     return false;
	     }
         else if ( ! x->extensible )
	     return false;
	 else
	     extend= x;
         return true;
	 };

         bool
AggregateType_Entity::
add_dynamic(AggregateType_Entity* x)
         {
	 if (extend || dynamic )
	     {
	     M::hl_internal(M::Mult_E_or_D );
	     return false;
	     }
         else if ( ! x->extensible )
	     return false;
	 else
	     dynamic= x;
         return true;
	 };

AggregateType_Entity::
AggregateType_Entity(const char *n):
         Grouping_Entity(n, AggregateType),
         extensible(false),
         extend(NULL),
         dynamic(NULL)
         {};

AggregateType_Entity::
AggregateType_Entity(const Entity_Name &en):
         Grouping_Entity(en, AggregateType),
         extensible(false),
         extend(NULL),
         dynamic(NULL)
         {};

         void 
AggregateType_Entity::
add_inherit( AggregateType_Entity* h )
         {
	 if ( !h || h->cl!= AggregateType )
	        {
	   	M::hl_internal(M::rec, "AggregateType_Entity::add_inherit() attempted to add non correct inheritance" );
		return;
                }
	 inheritance.push_back( h );
	 };


         Entity*               
AggregateType_Entity::
Local_and_Inherited_Name_LookUp(const Entity_Name& en) const // search in the container, too.
         {
	 Entity* x=Local_Name_LookUp(en);
	 if (!x ) x= Local_Name_LookUp_aggregate(en);
	 
	 if (!x ) 
	     for( InerIter i= inheritance.begin(); i!=inheritance.end(); ++i )
	         if (x = (*i)->Local_and_Inherited_Name_LookUp(en) ) break;
         return x;
	 }

         AggregateType_Entity* 
AggregateType_Entity::
Local_and_Inherited_Name_LookUp_aggregate(const Entity_Name& en) const //
         {
	 Entity* x= Local_Name_LookUp_aggregate(en);
	 if (!x ) 
	     for( InerIter i= inheritance.begin(); i!=inheritance.end(); ++i )
	         if (x = (*i)->Local_and_Inherited_Name_LookUp_aggregate(en) ) break;
         return (AggregateType_Entity*)x;
	 }



         Entity* 
AggregateType_Entity::
Scope_Name_LookUp(const Entity_Name& op) const // search in the owner, too.
         {
	 Entity* x=Local_and_Inherited_Name_LookUp(op);
	 if (!x ) x= Local_and_Inherited_Name_LookUp_aggregate(op);
	 
	 
	 if (!x && get_container())
	    x= get_container()->Scope_Name_LookUp(op);
	 
	 return x;
	 };

         AggregateType_Entity*
AggregateType_Entity::
Scope_Name_LookUp_aggregate(const Entity_Name& op) const // search in the owner, only aggregate too.
         {
	 AggregateType_Entity* x=Local_and_Inherited_Name_LookUp_aggregate(op);
	 if (!x && get_container())
	    x= get_container()->Scope_Name_LookUp_aggregate(op);
	 return x;
	 };

// ==========================================
         void 
Enumeration_Entity::
simple_output(ostream &os, int indent) const
         {
	 spaces(os, indent);
	 os <<  name << " Enumeration #=" << Elements.size() << endl;
	 };

         void 
Namespace_Entity::
simple_output(ostream &os, int indent) const
         {
	 const char* n;
	 spaces(os, indent);
	 os <<  name << " Namespace #=" << Elements.size() << endl;
         };


// ============================================= Type



Aggregate::
Aggregate(Grouping_Entity* e):
         Elementary(aggregate),
         TheAggregate(e)
         {};

         void 
Aggregate::
out_Elementary(ostream& os) const
         {os << TheAggregate->name; }

// =============================================================================
         void 
Type::
output(ostream &os) const
         { 
	 const Elementary * e= get_inner();
	 e->out_Elementary(os);
	 os << " ";
	 output_compound(os, ".");
	 };


         void 
Type::
output(ostream &os, const char* s) const
         { 
	 const Elementary * e= get_inner();
	 e->out_Elementary(os);
	 os << " ";
	 output_compound(os, s);
	 };

         void 
Type::
output_compound(ostream &os, const char* s) const
         {
	 output_compound_pre(os, s );
	 output_compound_post(os);
	 };



         void 
Direct_Compound::
output_compound_pre(ostream &os, const char* s) const
         {
	 if (inner_type) inner_type->output_compound_pre(os, s);
	 }
         void 
Direct_Compound::
output_compound_post(ostream &os) const 
          { 
	  if (inner_type) inner_type->output_compound_post(os); 
	  }



          void
Pointer::
output_compound_pre(ostream &os, const char* s) const
          {
	  os << "(*";
	  if (inner_type) inner_type->output_compound_pre(os, s);
	  }

          void 
Pointer::
output_compound_post(ostream &os) const 
          {
	  if (inner_type) inner_type->output_compound_post(os);
	  os << ")";
	  }



          void
Direct::
output_compound_pre(ostream &os, const char* s) const
          {
	  os << "(@ ";
	  if (inner_type) inner_type->output_compound_pre(os, s);
	  }

          void 
Direct::
output_compound_post(ostream &os) const 
          {
	  if (inner_type) inner_type->output_compound_post(os);
	  os << ")";
	  }






          void
Reference::
output_compound_pre(ostream &os, const char* s) const
          {
	  os << "(&";
	  if (inner_type) inner_type->output_compound_pre(os, s);
	  }

          void 
Reference::
output_compound_post(ostream &os) const 
          {
	  if (inner_type) inner_type->output_compound_post(os);
	  os << ")";
	  }

          void 
Array::
output_compound_post(ostream &os) const 
          { 
	  if (inner_type) inner_type->output_compound_post(os);
	  os << "[" << size << "]";
	  }

          bool 
Array::
is_equal(const Type* t)const
         { return t->k==array && size==((Array*)t)->size && inner_type->is_equal( ((Array*)t)->inner_type ); }

          bool 
Aggregate::
is_equal(const Type* t)const
         { return t->k==aggregate && TheAggregate==((Aggregate*)t)->TheAggregate; }

          bool 
Built_in::
is_equal(const Type* t)const
         { return t->k==built_in && The_built_in==((Built_in*)t)->The_built_in; }

          bool 
Unresolved_overloadable::
is_equal(const Type* t)const
         { return t->k==unresolved && ov==((Unresolved_overloadable*)t)->ov; }


         void
Function::
output_compound_post(ostream& os) const
         {
	 if (inner_type) inner_type->output_compound_post(os);
	 os << "( ";
	 Parameters.one_line_local_output(os);
	 os << " ) ";
	 };

Function::
Function( Entity_Container* ec):
         Direct_Compound(function),
         Parameters( *new Parameters_Entity )
         { Parameters.set_container(ec); };

Function::
~Function()
         {delete &Parameters;}


         bool 
Function::
is_equal(const Type* t)const
         { 
	 if( t->k!=function) return false;
	 Parameters_Entity::ElemIter i;
	 Parameters_Entity::ElemIter j;
	 for ( i= Parameters.Elements.begin(),
	       j= ((Function*)t)->Parameters.Elements.begin();
	       i!= Parameters.Elements.end() &&
	       j!= ((Function*)t)->Parameters.Elements.end();
	       i++, j++ )
	       {
	       if (  !
		      ((Simple_Entity*)(*i))->Get_Type()->
		          is_equal(
	                           ((Simple_Entity*)(*j))->Get_Type()
		                  )
		  )
		    return false;
	       }
	 return true;
	 };

// ====================================================
         void
Direct_Compound::
set_inner(Type* t)
          {
	  if ( inner_type ) 
	      inner_type->set_inner(t);
	  else
	      inner_type=t;
	  }

          const Elementary* 
Direct_Compound::
get_inner() const
          {
	  if (inner_type)  
	     return inner_type->get_inner();
	  else
	     return new Built_in(None_TYPESPEC);
	  }

          bool 
Direct_Compound::
is_equal(const Type* t)const
          { 
	  return t->k==k &&    // if it is equal k the '*t' is Direct_Compound and the the following conversion has meaning
	         inner_type->is_equal(  ((Direct_Compound*)t)->inner_type ); 
	  }

// =====================================================

         void 
Built_in::
out_Elementary(ostream &os) const
         {
	 bool f=false;
         if( The_built_in & Bool     )   { os << "bool "; f=true; }
	 if( The_built_in & Unsigned )   { os << "unsigned "; f=true; }
	 if( The_built_in & Signed   )   { os << "signed "; f=true; }
	 if( The_built_in & Long     )   { os << "long "; f=true; }
	 if( The_built_in & Short    )   { os << "short "; f=true; }
	 if( The_built_in & Int      )   { os << "int "; f=true; }
	 if( The_built_in & Char     )   { os << "char "; f=true; }
	 if( The_built_in & Double   )   { os << "double "; f=true; }
	 if( The_built_in & Float    )   { os << "float "; f=true; }
	 if( The_built_in & Void     )   { os << "void "; f=true; }
	 if( The_built_in & Wchar_t  )   { os << "wchar_t "; f=true; }
	 if( The_built_in & Error )      { os << "error"; f=true; }
	 if( !f )  os << "<internal incoherence>"; 
	 };

         void 
Unresolved_overloadable::
out_Elementary(ostream &os) const
         {
	 os << "(unresolved " << ov->name<< ")";
	 };
// ==================================== types cloning
         Type*
Direct::
clone() const
         { 
	 Type * t = new Direct();
	 t->set_inner( inner_type->clone() );
	 return t;
	 };

         Type*
Pointer::
clone() const
         { 
	 Type * t = new Pointer();
	 t->set_inner( inner_type->clone() );
	 return t;
	 };

         Type*
Reference::
clone() const
         { 
	 Type * t = new Reference();
	 t->set_inner( inner_type->clone() );
	 return t;
	 };

         Type*
Function::
clone() const
         { 
	 Type * t = new Function(Parameters.get_container());    // WARNING: here no parameters are cloned!!!
 	 t->set_inner( inner_type->clone() );
	 return t;
	 };

         Type*
Array::
clone() const
         { 
	 Type * t = new Array( size );
	 t->set_inner( inner_type->clone() );
	 return t;
	 };

         Type*
Aggregate::
clone() const
         { 
	 Type * t = new Aggregate( TheAggregate );
	 return t;
	 };

         Type*
Built_in::
clone() const
         { 
	 Type * t = new Built_in( The_built_in );
	 return t;
	 };

         Type*
Unresolved_overloadable::
clone() const
         { 
	 Type * t = new Unresolved_overloadable( ov );
	 return t;
	 };

// ===================================================================
         Type*
Unresolved_overloadable::
resolve( const list<Type*>* L1 ) const
         {
	 const list<Particular_overloadable*>& F= ov->Get_Functions();
	 Type* return_type=NULL;
	 
	 for( list<Particular_overloadable*>::const_iterator i= F.begin(); i!=F.end(); ++i )
	     {
	     Parameters_Entity& P=(*i)->T->Parameters;
             if (P.Elements.size() != L1->size() ) continue;
	     
	     bool found=true;
	     Parameters_Entity::ElemIter j1= P.Elements.begin();
	     list<Type*>::const_iterator      j2= L1->begin();        
	     while( j1!= P.Elements.end() && j2 != L1->end() ) 
	         {
		 if (  (*j1)->cl!= Entity::Simple )
		    {
		    M::hl_internal(M::fatal, "Unresolved_overloadable::resolve() non Simple_Entity in parameter" );
		    found=false;
		    break;
		    }
		 
		 if ( ! ((Simple_Entity*)(*j1))->Get_Type()->is_equal(*j2)  ) 
		    {
		    found=false;
		    break;
		    }
		 ++j1; ++j2;
		 }
	     if (found) 
	         {
		 return_type= (*i)->T->inner_type->clone();
		 break;
		 }
	     }
	 if ( !return_type ) return_type= new Built_in(Error);
	 return return_type;
	 }


// ===================================================================

Symbol_set Scope::symbol_table;

            bool
Symbol_set::compare::
operator()(const char* x, const char* y) const  // this is a substitute for less<...> of STL
	    {
	    bool a= ( strcmp(x,y)<0 );
//	    cerr << "compare '" << x << "' and '" << y << "' yeld " << a <<endl;
	    return a; 
	    }


            const char* 
Symbol_set::
Update(const char* a)   
                                            // is there? --> return a pointer,
          {                                 // isn't there? --> make a copy and return a pointer to it
          const char* r;
          pair<Container::iterator, bool> p= s.insert(a);
          if (p.second)
              {
	      r=new char[strlen(a)+1];
	      strcpy((char*)r,a);
	      
	      typedef const char* charpointer;
	      charpointer& x= *(p.first);     // WARNING: non portable construct
	      x= r;                           // this force a variatio in the pointer stored s
		                              // such a variation is forbidden by STL!
	      }
          else
              r=*p.first;
          return r;
          }


          void 
Symbol_set::
output(ostream& os=cerr) const
          {
	  for( Container::iterator i= s.begin(); i != s.end(); i++)
	     os.form("%s %p\n", *i, *i );
	  os.flush();
	  }


