#include <strstream.h>
#include "frontend.h"
#include "messages.h"

     void 
Token_Source::
put_back_token( const A_token& t)     // this has the effect to set the next wonted token
     {
     wonted_token= t;
     }

     A_token 
Token_Source::
inner_lexer1()
     {
     return inner_lexer();
     }


Token_Source::
Token_Source(Scope& sc):
     w(NULL),
     current_scope(sc)
     {
     wonted_token.tokenid=0;
     }


     void
Token_Source::
Init_Window(Window_on_a_Stream<A_token,10, Token_Source>* ww)
     {
     delete w;
     w=ww;
     }

// ========================================================= Token_Buffer_tiny
     void
Token_Buffer_tiny::
add_token( const A_token& t)
     {
     tiny_token t1;
     t1.tokenid= t.tokenid;
     t1.line=    t.line;
     t1.include_file= t.include_file;
     t1.include_file_line= t.include_file_line;
     t1.aux= t.aux;
     
     switch ( t1.tokenid )   // this is a sort of partial un-filtering
                             // it is a way to force another search of the associated entity
                             // douring filtering
         {
	 case TYPENAME:
	 case PTYPENAME:
	 case PSEUDO_TYPE:
	 case TYPENAME_DEFN:
	 case PTYPENAME_DEFN:
	 case IDENTIFIER_DEFN:
	     t1.tokenid= IDENTIFIER;
             break;	 
	 default: 
	     break;
	 }
     seq.push_back(t1);
     }


     A_token 
Token_Buffer_tiny::
inner_lexer()
     {
     tiny_token tt;
     if ( position== seq.end() )
        {
        tt= * (--seq.end() );
	tt.tokenid= END_PRE_PARSED;
        }
     else
        tt= *(position++);
     
     A_token t;
     t.tokenid= tt.tokenid;
     t.line= tt.line;	    
     t.include_file= tt.include_file;
     t.include_file_line= tt.include_file_line;
     t.aux=tt.aux;
     
     t.begin_pre_string=0;  
     t.begin_token_string=0;     
     t.end_token_string=0;  
     return t;
     }




Token_Buffer_tiny::
Token_Buffer_tiny(Scope& sc):
     Token_Buffer(sc) 
     {
     
     position= seq.end();
     }

     void
Token_Buffer_tiny::
reset()
     {
     position= seq.begin();   // the followin line read some token
     Init_Window( 
	   new Window_on_a_Stream<A_token,10, Token_Source>( *(Token_Source*)this, Token_Source::inner_lexer )
                );
     }




// ========================================================= Cxx_lexer
Cxx_lexer::
Cxx_lexer(istream *in,  Scope &sc, int q):
          yyFlexLexer(in),
          stream_position( in->tellg() ),
          beginning_of_pre_string(0),
          last_emitted(true),
          Token_Source(sc)
          {
	  Init_Window( 
	     new Window_on_a_Stream<A_token,10, Token_Source>( *(Token_Source*)this, Token_Source::inner_lexer )
                      );

	  if (q) set_debug(1);
	  };


// ========================================================= Cxx_parser

Cxx_parser::
Cxx_parser( istream& in, Grouping_Entity& db, istream& in_for_emit,  int d):
         count_syntax_errors(0),
         current_skip_buffer(&Null_skip_buffer),
         current_scope(db),
         Global(&db),
         S(in_for_emit, cout),
         yydebug(d&Parser)
         {          // this is after all because it began to read token (an then to access scope)
	 Lexer_Analizer= new Cxx_lexer(&in, current_scope, d&Lexer);
	 L=Lexer_Analizer;   // current source is the Lexer
	 }

Cxx_parser::
~Cxx_parser()
         {
	 delete Lexer_Analizer;
	 }



         void
Cxx_parser::
push_source( Token_Source& s)
         {
	 saved_L.push_front(L);
	 L=&s;
	 }

         void
Cxx_parser::
pop_source()
         {
	 L= *saved_L.begin();
	 saved_L.pop_front();
	 }




     void 
Cxx_parser::
syntax_error( const char* s )
     {
     M::message_header( "parse error");
     cerr << s << endl;
     ++count_syntax_errors;
     };


            Function* 
Cxx_parser::
begin_parameters()
            {
            Function *f= new Function(current_scope.Get_Container());
            Parameters_Entity& ns=f->Parameters;
            current_scope.Push(ns);
            current_definition.push(); current_definition.top().null();
            return f;
            };

            void
Cxx_parser::
end_parameters()
            { 
            current_scope.Pop(); 
            current_definition.pull();
            };

            void
Cxx_parser::
reset_type_qualifier_scope()
            {
            if (scope_for_scope_qualifier)
                  {
                  scope_for_scope_qualifier=false;
                  current_scope.Pop();
                  }
            };



// the followin function clones the type of an entity.
// The type returned is the type for the entity when it is cited with its name
// inside an expression.
//
// NULL value for 'e' is allowed, mean entity undeclare and then an error occured.
      Type* 
Cxx_parser::
get_type_from_entity( Entity* e ) const
            {
	    Type *t= NULL;
	    if ( e )
		 switch( e->cl )
	            {
		    case Entity::Simple:
		         t= ((Simple_Entity*)e)->Get_Type()->clone(); break;
		    case Entity::Overloadable:
		         t= new Unresolved_overloadable((Overloadable_Entity*)e); break;
		    case Entity::Function_E:
		         t= ((Function_Entity*)e)->T->clone(); break;
		    case Entity::EnumElement:
		    case Entity::Enumeration:
		         t= new Built_in(Int); break;
		    case Entity::AggregateType:
		         t= new Aggregate((AggregateType_Entity*)e); break;
		    default: 
		         t= new Built_in(Error); break;
		    }
	    else
	         t= new Built_in(Error);
		 
	    return t;
	    }


      Type* 
Cxx_parser::
applay_operator(Type* type, A_token token ) const
      {
      if ( type->k== Type::built_in &&  ((Built_in*)type)->The_built_in == Error)  return type;
      
      Type *return_type=NULL;
      Type *type2=NULL;   
      if ( type->k==Type::reference )     // a reference has no effect, strip it
	 {
	 type2= ((Reference*)type)->inner_type;
	 ((Reference*)type)->inner_type=NULL;
	 delete type;
	 }
      else
	 type2=type;

      
      // from now only "type2" has meaning
      switch(token.tokenid)
	 {
	 case '[':
	 case '*':
	     if ( type2->k==Type::pointer || type2->k==Type::array )
	         {
	         return_type=  ((Direct_Compound*)type2)->inner_type;
		 ((Direct_Compound*)type2)->inner_type=NULL;
		 delete type2;
		 }
	     break;
 	 case '&':
	     return_type= new Pointer();
	     return_type->set_inner(type2);
	     break;
	 case '~':
	 case '-':
	 case '+':
	 case PLUSPLUS:
	 case MINUSMINUS:
	 case '!':
	     return_type= type2;   //WARNING no check for non applayable operator or redefined operator
	     break;
	 default:
	     M::hl_internal(M::rec, "Cxx_parser::applay_operator(Type*, A_token) bad token");
	     break;
	 }
      
      if (!return_type)
	  {
	  return_type= new Built_in(Error);
	  delete type2;
	  }
      return return_type;
      }



      AggregateType_Entity*
Cxx_parser::
get_current_class() const
      {
      Entity_Container* cc= current_scope.Get_Container();
      while ( cc && cc->cl!=Entity::AggregateType )
	 cc=cc->get_container();
      return (AggregateType_Entity*)cc;
      }




      void 
Cxx_parser::
delete_ListTypes( list<Type*>* t ) const
      {
      for( list<Type*>::iterator i= t->begin(); i!= t->end(); ++i ) // delete all types
	  delete *i;
      delete t; // delete the list
      }


      Type* 
Cxx_parser::
apply_function( Type* f, const list<Type*>* L) const
      {
      if ( f->k== Type::built_in &&  ((Built_in*)f)->The_built_in ==Error)  return f;
      Type* return_type=NULL;
      if ( f->k == Type::function ) 
	  {          // doesn't do type check
          return_type=((Function*)f)->inner_type;
          ((Function*)f)->inner_type= NULL;
          delete f;
          }
      else if ( f->k == Type::unresolved )
          {
	  return_type= ((Unresolved_overloadable*)f)->resolve(L);
	  delete f;
	  }
      else
          return_type= new Built_in(Error);
      return return_type;
      }


      void
Cxx_parser::
template_begin_instantiation( Entity* &e, const Entity_Name& e_name )
                  { 
		  bool done= false;
		  if (!e)   // template already istantiated
		      {    //WARNING we must check what kind (function or class) of template it is or not???
                      Template_Entity& templ= *e_name.Get_Template();
		      list<Type*>* act_parms= e_name.Get_Template_parmeters();
		      
		      if( templ.p.Elements.size() != act_parms->size() )
			   {
			   M::hl_error(M::Template_Wrong_ParNum);
		           e= &current_scope.add_Entity(new AggregateType_Entity(e_name)); // we add a fictitious insance
			   done=true;
			   }


		      //if an actual parameter is a parameter of a template, we can't instantiate it
		      if ( !done )
			   {
			   for( list<Type*>::const_iterator i=act_parms->begin(); i!=act_parms->end(); ++i)
			        {
				Type* t1= *act_parms->begin();
                                if ( t1->k == Type::aggregate )
			            {
				    Aggregate* t= (Aggregate*) t1;
                                    Entity_Container* ec= t->TheAggregate->get_container();
				    if ( ec->cl == Entity::Parameters &&  ec->get_container()->cl == Entity::Template )
				         {
			                      // message
		                         ostrstream s;   
		                         s << "Not istanziated: " << e_name << ends;
		                         M::hl_internal(M::warn, s.str() );
		                         delete s.str();
					 
					      // we add a fictitious insance
		                         e= &current_scope.add_Entity(new AggregateType_Entity(e_name)); 
					 done=true;
					 break;
					 }
			            }
			       }
			   }
          



		      if (!done)
			   {
			   e= &Global->add_Entity(new AggregateType_Entity(e_name));  // this is a real instance
			   
			   // here we mast prepare the typedef for actual paramters
			   list<Type*>::iterator i;
			   Parameters_Entity::ElemIter j;
                           for( i= act_parms->begin(),  j= templ.p.Elements.begin();
			        i!=act_parms->end();
			        ++i, ++j )
		           	{
				const char * n= (*j)->name.Get_str();  // name of parameter
				Type* TheType= (*i)->clone();      // type type of the parameter
		                ((AggregateType_Entity*)e)->add_Entity( new Simple_Entity(n, Typedef, TheType ) );
		                }
		           
		           	  
		           	// Here the source of token is changed to create a new instance
		           	// the buffer begin with PRE_PARSED_CLASS_DECL and then
		           	// "template_instantiate_once" will be activated
		           	//
		           	// "template_instantiate_once" will execute "pop_source()"
		           	//
			   templ.get_buffer().reset(); // begin reading from start
                           push_source( templ.get_buffer() );     // change source of tokens
			     
			        // message
//		           ostrstream s;   
//		           s << "begin instatiation: " << e_name << ends;
//		           M::warning(99, s.str() );
//		           delete s.str();
			     
	                   done=true;
			   }
                      }
		  }




// expr_or_declarator is a part of a declaration and then return
// a compound type made of "direct, pointer, reference" to something.
// example:
//   * ( * & x)
// it is returned 
//    the type "reference to pointer to pointer to direct" 
//    the name "x"
//    the entity associated to "x" by the current scope if it exist
// 
//
// The syntax is the same as an expression.
//
// convert_expr_or_declarator() is a function that take information from 
// expr_or_declarator an compute the expression on the entity returning 
// the type of the expression.

     Type*
Cxx_parser::
convert_expr_or_declarator(const A_name_entity_type &x) const
     {
     Type* expr_ptr= x.t;  // this scan the type 'x.t' for interpreting it as an expression
     
       
     Type* original_type= get_type_from_entity( x.e ); // get a clone of the type of 'x.e'
     Type* current_type= original_type;  // this scan the type of the entity
       
     bool correct=true;
     while ( expr_ptr && correct )
        {
        switch (expr_ptr->k)
             {
             case Type::direct :
                 // do nothing
	         expr_ptr= ((Direct*)expr_ptr)->inner_type;
                 break;
	     
             case Type::pointer :     // dereferencing
                 if (current_type->k==Type::pointer)
	            current_type= ((Pointer*)current_type)->inner_type; // WARNING: it doesn't free memory
	         else
	            {
	            M::hl_warning(M::Type_Mismatch);
		    delete current_type;
		    current_type= new Built_in(Error);
		    correct=false;
		    }
	         expr_ptr= ((Pointer*)expr_ptr)->inner_type;
	         break;

             case Type::reference :    // get pointer 
                 {
		 Type* temp= new Pointer();
		 temp->set_inner(current_type);
		 current_type= temp;
	         expr_ptr= ((Reference*)expr_ptr)->inner_type;
		 }
	         break;

	     case Type::array:     
	     case Type::aggregate: 
	     case Type::built_in:
	     case Type::unresolved:
	     case Type::function:
             default:
	          M::hl_internal(M::rec, "Cxx_parser::convert_expr_or_declarator(): incoherent type");
	          delete current_type;
		  current_type= new Built_in(Error);
		  correct=false;
	          break;
             }
        }
     
     return current_type;     
     }

