
// --------------------------------------------
// global_attr.h
//
// global data
//
#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <iostream.h>
#include "messages.h"

typedef char* PtrToFilename;

typedef int t_id;  // token identification type

enum debug_flag 
    {
    Parser=1,
    Lexer=2
    };


enum SCSPEC_value  // storage class specifier
    {
    None_SCSPEC=0,
    Auto=1, 
    Extern=2,
    Friend=4,
    Inline=8, 
    Mutable=16, 
    Register=32, 
    Static=64, 
    Typedef=128, 
    Virtual=256,
    };

enum VISSPEC_value // visibility specifier
    {
    None_VISSPEC,
    Private,
    Protected,
    Public
    };

enum TYPESPEC_value // type specifier
    {
    None_TYPESPEC=0,
    Bool=1,
    Char=2,
    Double=4,
    Float=8,
    Int=16,
    Long=32,
    Short=64,
    Signed=128,
    Unsigned=256,
    Void=512,
    Wchar_t=1024,
    Error=2048
    };


enum TYPE_QUAL_value // type qualifier
    {
    None_TYPE_QUAL=0,
    Const=1,
    Volatile=2
    };

enum Operator_ID   // identifiers for re-definable operators
   {
   Op_None,
   Mul,         // *
   Div,	        // /
   Mod,	        // %
   Sum,	        // +
   Sub,	        // -
   Bit_And,     // &
   Bit_Or,      // |
   Bit_Xor,     // ^
   Bit_Not,     // ~
   Comma,       // ,
   Less_Equal,  // <=
   Greater_Equal, // >=
   Less,        // <
   Greater,     // >
   Equal,       // ==
   Not_Equal,   // !=
   Sum_Assign,  // +=
   Sub_Assign,  // -=
   Mul_Assign,  // *=
   Div_Assign,  // /=
   Mod_Assign,  // %=
   Bit_Xor_Assign, // ^=
   Bit_And_Assign, // &=
   Bit_Or_Assign,  // |=
   RShift_Assign,  // >>=
   LShift_Assign,  // <<=
   Assign,         // =
   RShift,         // >>
   LShift,         // <<
   PlusPlus,       // ++
   MinusMinus,     // --
   Logic_And,      // &&
   Logic_Or,       // ||
   Logic_Not,      // !
   Question_Colon, // ?:
   MinMax,   //??? c'era in g++
   Pointsat,       // ->
   Pointsat_Star,  // ->*
   Call,           // ()  function or member call
   Array_deref,    // [.]
   New,            // new .
   Delete,         // delete .
   New_Array,      // new . [.]
   Delete_Array    // delete[] .                   
   };









#ifndef ONLY_GLOBAL_TYPES

// Flags and other for info from command line
extern int print_symbol_table;
extern debug_flag d;       // default: no debug
extern bool define_static_members;  // default declare extern
  
extern bool debug_parser;

extern unsigned debug_line_start;
extern unsigned debug_line_end;

extern PtrToFilename filename;




// global compile information
extern unsigned Line;   // contain the line of the look-ahead token
                       // setted by 'int yylex(...)'

extern const char * include_file;      // contain pointer to the string of the name of the file in which is 
                                       // contained the look-ahead token
extern unsigned include_file_line;    // contain line number of the look-ahead token in the include file

  
#endif


#endif

