
#include "global.h"
#include "frontend.h"
#include "parser_types.h"
#include "messages.h"


    A_token 
Token_Source::
next_token()
   {
   if (wonted_token.tokenid != 0)    // wonted token has precedence over the stream
      {
      A_token t=wonted_token;
      wonted_token.tokenid=0;
      return t;
      }
   return filter();
   }

    A_token 
Token_Source::
filter()
   {
   A_token& t= w->get_and_advance();     // w->get(0) obtain the next token, now.
   A_token next;     // prossimo token
   switch (t->tokenid)
      {
      case SCSPEC:
         next=w->get(0);
         if ( t->aux.sc == Extern
              && next->tokenid == STRING )
            {
            w->get_and_advance();    // drop token STRING
            t->tokenid=EXTERN_LANG_STRING;
            }
         break;
      case IDENTIFIER:
         {
         t->aux.id.e=current_scope.Name_LookUp(Entity_Name(t->aux.id.s));   // search an entity associated to the name in the scope
         if ( t->aux.id.e )  // it has an entity associated?
            switch( t->aux.id.e->cl )
                {
                case Entity::Simple:
                    {
                    Simple_Entity * ee= (Simple_Entity*)(t->aux.id.e);
                    if ( ee->Get_SC() & Typedef ) // and it is a typedef?
                            t->tokenid= TYPENAME;
                    }
                    break;
		case Entity::Overloadable:
		    {
		    Overloadable_Entity* ee= (Overloadable_Entity*)(t->aux.id.e);
                    if ( ee->Get_SC() & Typedef ) // and it is a typedef?
                            t->tokenid= TYPENAME;
		    }
		    break;
                case Entity::Enumeration:
                case Entity::AggregateType:
                     if ( w->get(-2).tokenid == SCOPE && current_scope.Get_Container()==t->aux.id.e  && w->get(0).tokenid=='(')
                          {   // referring a constructor from outside his class is a particular case
                          t->aux.id.e= current_scope.Name_LookUp(Entity_Name(Entity_Name::constructor));
                          }
                     else
                         t->tokenid=TYPENAME;
                    break;
                case Entity::Template:
                     if ( w->get(-2).tokenid == SCOPE && current_scope.Get_Container()==t->aux.id.e )
                          {   // referring a constructor from outside his class is a particular case
                          t->aux.id.e= current_scope.Name_LookUp(Entity_Name(Entity_Name::constructor));
                          }
                     else  if ( w->get(0).tokenid == '<' )   // it must be followed by '<'
		          {
                          t->tokenid=PTYPENAME;
			  }
                    break;
		     
                default:
                    break;
                }
	 /*
	 else
	       // WARNING: this is for non catched type with definition inside templates
	       //          it is used in the grammar as TYPENAME
	       // it will go away when templates will be instantiated
	    if ( w->get(-2).tokenid == SCOPE )
	           {
		   Entity_Container* ec_save= current_scope.Get_Container();
		   current_scope.Pop();    // leave the momentary scope for scope resolution operator
                   
		   if ( ! (
		             (current_scope.Get_Container()->cl != Entity::Template && 
			      current_scope.Get_Container()->get_container()==NULL )
		                         ||
		       
		             (current_scope.Get_Container()->cl == Entity::Template &&
		              current_scope.Get_Container()->get_container()->get_container()==NULL )
			)
		      )
		         t->tokenid= PSEUDO_TYPE;
		   
		   current_scope.Push(*ec_save);
		   }
         */


        
         // filter `t': it could be an IDENTIFIER_DEFN or TYPENAME_DEFN
         
         A_token& a= w->get(-2);
         if ( a->tokenid==AGGR )   // preceded by AGGR, maybe we must change it
            {
            switch ( w->get(0)->tokenid  )
               {
               case ';':    // it must be checked is not a "frined class x;"
                   if (  w->get(-2)->tokenid== SCSPEC &&    w->get(-2)->aux.sc==Friend    )
                       break; // not changed
               case '{':
               case ':':
                   switch( t->tokenid )
                     {
                     case TYPENAME:
                        t->tokenid= TYPENAME_DEFN ;  break;
                     case PTYPENAME:
                        t->tokenid= PTYPENAME_DEFN ; break;
                     case IDENTIFIER:
                        t->tokenid= IDENTIFIER_DEFN ; break;
                     default:
		        M::hl_internal(M::Token_filter); break;
                     }
               }
            }
         }
      default:
         break;
      };
   return t;
   };







ostream& operator<< (ostream& os, const A_token& t)
   {
   os   << t.token_string() << ' '
        << t.tokenid << ' '
        << t.line << ' '
        << t.begin_pre_string << ' '
        << t.begin_token_string << ' '
        << t.end_token_string ;   
   return os;
   };




    const char* 
A_token::
token_string() const
    {
    const char *ss;
    switch(tokenid)
        {
        case IDENTIFIER:
        case IDENTIFIER_DEFN:
        case TYPENAME:
        case TYPENAME_DEFN:
        case PTYPENAME:
        case PTYPENAME_DEFN:
           ss= aux.id.s; break;
        default:
           ss= "<unknown>"; break;         
        }
    return ss;
    };







   int 
Cxx_parser::
yylex (YYSTYPE *lvalp)
   {
   lvalp->UA_token=L->next_token();
   Line= lvalp->UA_token.line;         // set the current line number
   include_file= lvalp->UA_token.include_file;
   include_file_line = lvalp->UA_token.include_file_line;
     
     
   if (debug_parser)
      {
      if ( yydebug==0 && Line >= debug_line_start && Line <=debug_line_end  ) yydebug=1;
      if ( yydebug==1 && Line > debug_line_end )   yydebug=0;
      }
     
   return lvalp->UA_token.tokenid;
   };

	   
	 int
Cxx_parser::
parse()
         {
         YYSTYPE lval;
	 t_id t= yylex(&lval);
	 if (t==ECO_CXX_SIGN)
	     delete_source(lval.UA_token.begin_token_string, lval.UA_token.end_token_string );
	 else
	     M::hl_error(M::Non_ECO_source);
	   
	 return yyparse();
	 }


void out_st()
   {
   Scope::symbol_table.gdb_out();
   };




     void 
Cxx_parser::
declare( A_name_entity_type& i )   //WARNING: this function can change `i'
     {
     A_name_entity_scope_type j;
     j.name=i.name;
     j.e=i.e;
     j.t=i.t;
     j.scope=current_scope.Get_Container();
     
     declare(j);
     
     i.name=j.name;
     i.e=j.e;
     i.t=j.t;
     };

     void 
Cxx_parser::
declare( A_name_entity_scope_type& i )   //WARNING: this function can change `i'
     {
     Entity *defined;
     if ( i.t && i.t->k==Type::direct )     // cancel direct type if necessary
           {
           Direct* tt= (Direct*)i.t;
           i.t=tt->inner_type;
           tt->inner_type=NULL; // inhibit deep deallocation
           delete tt;             
           }
     
     if ( current_scope.Get_Container()->cl == Entity::Template )   // are we defining a template?
           {
	   Entity_Container* templ= current_scope.Get_Container(); // this is the template
	   Entity_Container* templ_container= templ->get_container(); // this is the Entity_Container where the template is
           templ_container->change_name( templ,  Entity_Name(*i.name));  // update the name of the template
	   }
     
     current_scope.Push(*i.scope);
     
     if ( i.t && i.t->k==Type::function )
           {
           Function* f= (Function*)i.t;

                                                             // ----------- non overloadable
                                                      
          if (i.name->k == Entity_Name::destructor )                                 // destructor
                  {
                  Function *t= new Function( current_scope.Get_Container() );       
                  t->set_inner( new Built_in(Void) );
                  i.e= &current_scope.add_Entity( new Function_Entity(*i.name, t));
                  }
          else if ( i.name->k == Entity_Name::oper &&                                // conversion
                    i.name->Get_op().k == Operator_Identifier::conversion                                
                   )                                                                                     
                  {
                  i.e= &current_scope.add_Entity( new Function_Entity(*i.name, f));
                  }
                                                            // ------------- overloadable
          else
	          {
                  if (i.name->k == Entity_Name::none )    // if it has no name then check if it is a constructor
                          if (
                               f->inner_type->k == Type::aggregate &&      // it return an aggregate
                               ((Aggregate*)f->inner_type)->TheAggregate== current_scope.Get_Container()
                             )
                               {
                               delete i.name;
                               i.name= new Entity_Name( Entity_Name::constructor );
                               i.e= current_scope.Get_Container()->Local_Name_LookUp(*i.name);
                               }
                          else 
                               {
			       M::hl_internal(M::Bad_request);
//                               cerr << "   attempted to declare " << *i.name << " of type "; f->output(cerr); cerr<<  endl;
			       i.e= &current_scope.add_Entity( new Function_Entity( *i.name, f )  );
                               goto abort_declare;
                               }
	          else
		          if ( current_scope.Get_Container()->cl == Entity::AggregateType )     // we are going to define the entity in an aggregate
			      {
			      AggregateType_Entity& ate= *(AggregateType_Entity*) current_scope.Get_Container();
			      if ( ate.name.k == Entity_Name::template_instance  &&     //this aggregate is a template instance
				   i.name->k == Entity_Name::string &&     // it is a name that is a string
			           strcmp( ate.name.Get_Template()->name.Get_str(), i.name->Get_str() )==0  // and its name is equal to the name of the entity we are defining
			          )
				    {
                                    delete i.name;
                                    i.name= new Entity_Name( Entity_Name::constructor );
                                    i.e= current_scope.Get_Container()->Local_Name_LookUp(*i.name);
				    }
		    
                              }

                                                                                          // for all other cases consider it an overloadable function
                   Overloadable_Entity* oe;
                   if ( !i.e || current_scope.can_be_shadowed(i.e) )          // already visible
                          oe= (Overloadable_Entity*)&current_scope.add_Entity( new Overloadable_Entity( *i.name, current_definition.top().sc ) );
                   else
                          {
                          if ( i.e->cl != Entity::Overloadable )
                               {
			       if ( i.e->cl == Entity::Template ) // ignore template user istantiation
			           i.e=&current_scope.add_Entity( new Function_Entity( *new Entity_Name("$$$-templ_usr_istant_placeholder"), f )  );
			       else
				   {
				   if (!(current_definition.top().sc & Friend))
			                M::hl_error(M::Wrong_overloading);     // error if not "friend"
//                                 cerr << "   attempted overloding on " << *i.name << endl;
//			           M::winternal("Cxx_parser::declare( A_name_entity_type& ) 2");
			           i.e=&current_scope.add_Entity( new Function_Entity( *i.name, f )  );
				   }
                               goto abort_declare;
			       }
                          else
                               oe=(Overloadable_Entity*)i.e;
                          }
		   i.e=&oe->add_Function( (Function*)i.t);    //WARNING: it doesn't check if it is already there
		   }
           }      

     else    // it is not a function
           {
           if ( !i.e || current_scope.can_be_shadowed(i.e) )   // already visible
                 {
                 if ( i.name->k != Entity_Name::string )
                       {
                       M::hl_internal(M::Bad_request);		       
//                       cerr << "   attempted to define non function " << *i.name << endl;
//		       M::winternal("Cxx_parser::declare( A_name_entity_type& ) 3");
                       goto abort_declare;
                       }
                 i.e= &current_scope.add_Entity( new Simple_Entity(*i.name, current_definition.top().sc , i.t) );    // WARNING: manca controllo
                 }
           else
                 {
		 M::hl_warning(M::Already_defined);
//               cerr << Line << ": " << *i.name << " already defined" <<  endl;
		 goto abort_declare;
                 }
           }
     
     abort_declare:
     //Last_Declared= i.e;
     current_scope.Pop();
     };


