
// -------------------------------------
// main.cc
//
// $Id: $


#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fstream.h>


#ifdef __MSDOS__
#include <cstring.h>
#endif

#include "frontend.h"
#include "pardefs.h"


#define ONLY_GLOBAL_TYPES
#include "global.h"

//------------- Global definition

int print_symbol_table=0;
debug_flag d= debug_flag(0);       // default: no debug
bool define_static_members= false;        // default declare extern

bool debug_parser=false;

unsigned debug_line_start=0;
unsigned debug_line_end=0;

PtrToFilename filename=NULL;




unsigned Line=0;   // contain the line of the look-ahead token
                   // setted by 'int yylex(...)'

const char * include_file=NULL;   // contain pointer to the string of the name of the file in which is 
                                  //     contained the look-ahead token
unsigned include_file_line=0;     // contain line number of the look-ahead token in the include file



// ======================================================================
// Command line arguments managment.
// This function
//         set filename to point to the right string if a filename is catched
//         set d to the proper value for debugging setting for Cxx_parser (see it for its use)
//         if no informations on the command line are given for the previous two item leave 
//               'filename' and 'd' unchanged
void args_managment(int argc, char **argv)
   {
   if ( !(argc>1) )
     {
     cout << "Use: ... [option] filename" << endl;
     cout << "Help: ... -h" << endl;
     exit(EXIT_SUCCESS);
     }

   for ( int i=1; i<argc; i++ )
     {
     if ( argv[i][0]=='-' )         // trattamento opzioni (parametri che iniziano per '-')
        {
            // debug
        if ( strcmp(argv[i]+1,"dp")==0 )  { debug_parser=true; debug_line_start=0; debug_line_end=31000 ;}   // debug parser
        else if ( strcmp(argv[i]+1,"dpb")==0 ) { debug_parser=true; debug_line_start=atoi(argv[i+1]);++i; continue;}
        else if ( strcmp(argv[i]+1,"dpe")==0 ) { debug_parser=true; debug_line_end=atoi(argv[i+1]); ++i; continue;}
        else if ( strcmp(argv[i]+1,"dl")==0 )  int(d) |= Lexer;   // debug lexer
	    // other
        else if ( strcmp(argv[i]+1,"g")==0 ) define_static_members=true;  // default declare extern
        else if ( strcmp(argv[i]+1,"iw")==0 ) M::display_internal_warning=true;
        else if ( strcmp(argv[i]+1,"w")==0 )  {M::set_warning_level(atoi(argv[i+1])); ++i; continue;}
        else if ( strcmp(argv[i]+1,"n")==0 )  M::display_preprocessed_line_number=true;
        else if ( strcmp(argv[i]+1,"h")==0 )
            {
            cout << 
	       "eco_prec is a precompiler that add ECO support to C++\n"
	       "written by Maurizio Pizzonia 1997  (pizzonia@inf.uniroma3.it)\n"
               "     -h:  this help\n"
	       "     -g:  define static member (default: declare extern)\n"
               "     -v:  verbose (output symbol table when the compilation reach the end)\n"
	       "     -n:  display preprocessed file line number in messages\n"
	       "          (default: display eco-file line number\n)"
	       "     -w <n>: set warning level to n (greater value -> more info emitted)\n"
	       "     -iw: display internal warning\n"
               "     -dl: scanner debugging on\n"
               "     -dp: parser debugging on\n"
	       "     -dpb <n>: start parser debug info from line n\n"
	       "     -dpe <n>: end parser debug info from line n\n"
               << endl;
               exit(0);
            }
        if ( strcmp(argv[i]+1,"v")==0 ) print_symbol_table=1; // output symbol table alla fine

        }
     else                          // trattamento filenames (parametri che non iniziano per '-')
        {
        if ( filename )
            {
            cerr << "I can't manage more then one file each time." << endl;
            exit(-1);
            }
        else
            {
            filename=argv[i];
            }
        }
     };
     if ( !filename )
        {
        cerr << "You must specify one filename." << endl;
        exit(EXIT_FAILURE);
        }
   };




int main(int argc, char **argv)
   {
   PtrToFilename filename_and_ext=NULL;

   args_managment(argc,argv);
#if 0   
   char * punto= strchr( filename, '.' );
   if ( !punto )
      {       // agginuge l'estensione .fml
      filename_and_ext= new char[strlen(filename)+5];
      strcpy( filename_and_ext, filename );
      strcat( filename_and_ext, ".cc" );
      }
   else
      filename_and_ext=filename;
#else
      filename_and_ext=filename;
#endif

   cerr << "\nECO C++ to C++ precompiler by Maurizio Pizzonia 0.1 (Alfa)" << endl;
 
   ifstream input(filename_and_ext);
   ifstream input_for_emit(filename_and_ext); //this is managed by the backend Substitutor
   
   if ( !input.good() || !input_for_emit.good()  )
       {
       cerr.form("I can't open file %s: %s\n", filename_and_ext, strerror(errno));
       exit(EXIT_FAILURE);
       }

   cerr << "Parsing " << filename_and_ext << " ..." << endl;
  
  
   Namespace_Entity db(NULL);

   Cxx_parser P( input, db, input_for_emit, d);
   int status;
   bool end_parsing=false;
   try 
      {
      status= P.parse(); 
      end_parsing=true;
      }
   catch ( char * s)
      { cerr << "compilation aborted due to " << s << endl; }
   catch ( ... )
      { cerr << "compilation aborted due to unknown exception."<< endl; }

   
   cerr << " -------------------" << endl
        << "Parser status: "     << status << endl
        << "Parse errors: "      << P.how_many_syntax_errors() << endl
        << endl;
   M::out_statistics( cerr );

   if (print_symbol_table)
        {
        cerr << "\nEntity DB:\n\n" << endl;
	db.deep_output(cerr,0);
        }
   
   if ( filename_and_ext != filename ) 
       delete filename_and_ext;

   if (!end_parsing || M::get_error_number()) 
       return EXIT_FAILURE;
   return EXIT_SUCCESS;
   };



void out_scope(Scope & s)
   {
   ofstream out("scope_dump");
   s.output(out);
   };
