
// -------------------------------------
// main.cc
//
// $Id: main_lexer_test.cc,v 1.1 1996/08/31 17:09:20 maurizio Exp $

#include <stdlib.h>
#include <string.h>
#include <fstream.h>

#include <String.h>   //WARNING: GNU only!

#ifdef __MSDOS__
#include <cstring.h>
#endif

#include "frontend.h"
#include "pardefs.h"
// #include "global.h"


typedef char* PtrToFilename;

// Flags for switch managment
int print_symbol_table=0;
int d=0;       // default: no debug
PtrToFilename filename=NULL;

istream* ECO_source;  // pointer to ECO source stream




// ======================================================================
// Command line arguments managment.
// This function
//         set filename to point to the right string if a filename is catched
//         set d to the proper value for debugging setting for Cxx_parser (see it for its use)
//         if no informations on the command line are given for the previous two item leave 
//               'filename' and 'd' unchanged
void args_managment(int argc, char **argv)
   {
   if ( !(argc>1) )
     {
     cout << "Use: ... [option] filename" << endl;
     cout << "Help: ... -h" << endl;
     exit(EXIT_SUCCESS);
     }

   for ( int i=1; i<argc; i++ )
     {
     if ( argv[i][0]=='-' )         // trattamento opzioni (parametri che iniziano per '-')
        {
        if ( strcmp(argv[i]+1,"dp")==0 ) d|=1;   // debug parser
        if ( strcmp(argv[i]+1,"dl")==0 ) d|=2;   // debug lexer
        if ( strcmp(argv[i]+1,"h")==0 )
            {
            cout
               << "-h: this help\n"
               << "-v: verbose (output symbol table when the compilation reach the end)\n"
               << "-dp: parser debugging on\n"
               << "-dl: scanner debugging on\n"
               << endl;
               exit(0);
            }
        if ( strcmp(argv[i]+1,"v")==0 ) print_symbol_table=1; // output symbol table alla fine

        }
     else                          // trattamento filenames (parametri che non iniziano per '-')
        {
        if ( filename )
            {
            cout << "I can't manage more then one file each time." << endl;
            exit(-1);
            }
        else
            {
            filename=argv[i];
            }
        }
     };
     if ( !filename )
        {
        cout << "You must specify one filename." << endl;
        exit(EXIT_FAILURE);
        }
   };



int main(int argc, char **argv)
   {
   PtrToFilename filename_and_ext=NULL;

   args_managment(argc,argv);
#if 0   
   char * punto= strchr( filename, '.' );
   if ( !punto )
      {       // agginuge l'estensione .fml
      filename_and_ext= new char[strlen(filename)+5];
      strcpy( filename_and_ext, filename );
      strcat( filename_and_ext, ".cc" );
      }
   else
      filename_and_ext=filename;
#else
      filename_and_ext=filename;
#endif
/*
   cout << "\nC++ code analisis system by Maurizio Pizzonia 0.0 (Alfa)" << endl;
   cout << "Parsing " << filename_and_ext << " ..." << endl;
 */
   ifstream input(filename_and_ext);
   ifstream input2(filename_and_ext);
   

   Entity_Table db(NULL);
   //Cxx_parser P( input, d );
   Cxx_lexer L(&input, db, d);
   try
      { 
      bool end_file=false;
      unsigned long token_lenght;
      char c;
      token t=token(0,0,0,0);
      token old_t=token(0,0,0,0);
      
      
      /*
      unsigned long da;
      unsigned long a;
      cin >> da >> a;
      cerr << "dump da " << da << " a " << a << endl;
	*/
      
      while ( !end_file )
         {
	 old_t=t;
	 t= L.next_token();
	 
/*	 
	 if (    t.end_token_string> da && t.end_token_string< a)
	     L.set_debug(1);
	 else
	     L.set_debug(0);
*/	     
	 if (t.getid()==END_OF_COMPILATION_UNIT)
	      {
	      end_file=true;
	      }
         token_lenght=t.end_token_string-t.begin_pre_string+1;
	 
	 
	 input2.seekg(t.begin_pre_string);
//	 if( L.debug() ) cerr<< t << "`";
	 for( int i=0; i<token_lenght; i++)
	     {
	     c=input2.get();
	     cout.put(c);
//	     if( L.debug() ) cerr.put(c);
	     }
//	 if( L.debug() ) cerr<<"'"<< endl;
	 }
      
//      cerr << "\nPrevious token:\n"<< old_t << endl;
//      cerr << "\nLast token:\n"<< t << endl;
      }       
   catch (...)
      {
      cout << "** Generata una eccezione sconosciuta." << endl;
      exit(EXIT_FAILURE);
      }
/*
   cout << " -------------------" << endl;
   cout << "Parser status: " << status << '\n';
   cout << "Errors: " << P.how_many_error() << endl;
   cout << "Warnings: " << P.how_many_warnings() << endl;
*/
   if (print_symbol_table)
        {
        cout << "\nSYMBOL DB:\n\n" << endl;
	db.output(cout,0);
	}

   if ( filename_and_ext != filename ) delete filename_and_ext;
   return 0;
   };

