
#ifndef __MESSAGES_H__
#define __MESSAGES_H__

class M
   {
   private:
        static int count_errors;
        static int count_warnings;
        static int count_internal_warnings;
        static int count_internal_errors;
        
        static int warning_level;
        static int count_non_displayed_warnings;


   public:
        enum type {fatal,rec,warn};
        static bool display_preprocessed_line_number;
        static bool display_internal_warning;
   
   
         // raw functions
        static void message_header(const char* t);
   
        static void warning( unsigned level,  const char * s);
        static void internal(const char*s);
        static void winternal(const char*s);
         
         // hi-level functions
        struct Error  
              {
	      type t;   // fatal or recoverable
	      const char* s;
	      };
        struct Warning 
              {
	      int level;
	      const char* s;
	      };
        struct Internal
              {
	      type t; // fatal, recoverable, warning
	      const char* s;
	      };
   
        static void hl_error(Error&);
        static void hl_warning(Warning&);
        static void hl_internal(Internal&);
        static void hl_internal(type, const char* s);
   
         // other
        static void out_statistics( ostream& );
        static void set_warning_level(int x) { warning_level=x;};
        static long get_error_number() {return count_errors;}
   
   
           // messages
   
        static Warning Already_defined;
        static Warning Type_Mismatch;
   
        static Error Output_Error;
        static Error Input_Error;
        static Error Too_Complex;
        static Error First_Costr_Parm;
        static Error Template_Wrong_ParNum;  //it must became a warning
        static Error Wrong_overloading;      //it must became a warning
        static Error Wrong_member;
        static Error Undeclared_symbol;
        static Error Non_ECO_source;
   
        static Internal Mult_E_or_D;
        static Internal Past_The_End;
        static Internal Useless_Freeze;
        static Internal Freeze_in_Subst;
        static Internal Subst_Exist;
        static Internal Subst_Overlap;
        static Internal Subst_NULL;
        static Internal Already_Freezed;
        static Internal Token_filter;
        static Internal Bad_request;
        static Internal Function_no_string;
  //      static Internal 
   
   };

#endif
