
#include <strstream.h>
#include "global.h"
#include "frontend.h"




    void 
Cxx_parser::
freeze( streampos p ) 
    {
    if (current_scope.Get_Container()==Global )     // freeze only if we are in the global namespace
        S.freeze(p);
    };

    void 
Cxx_parser::
delete_source( streampos from, streampos to )
    {
    if (!can_modify() ) return;
    const char *s= new char('\0');
    S.substitute( from, to-from+1, s );
    };


    const char *
Entity::
qualified_name() const   // allocate a null terminated string containing the qualified name (starting form global namespace)Grouping_Entity::
         {
	 ostrstream s;
	 if ( !container )
	     s << ends;
	 else
	     {
	     const char * s1= container->qualified_name();
             s << s1 << "::" << name << ends;
	     delete s1;
	     }
	 return s.str();    // the string is no more owned by 's'
	 }






                      // WARNING: it doesn't work if the class for which this function is called                       
                      // is  declared inside another (the problem is the static definition after the ending right curly
                      // WARNING: it doesn't work with struct because of default public members instead of private                    

// it must be called with current_scope still in the class, current scope must be
// in an AggregateType_Entity

    void
Cxx_parser::
modify_class( AggregateType_Entity* e, A_token leftcurly, A_token rightcurly )
    {
    if (!can_modify() ) return;
    if (!e ) return;
    if ( ! e->Get_Extend() && !e->Get_Dynamic() && !e->is_extensible() ) return;
    
    const char * e_qual_name= e->qualified_name(); // qualified name of the entity '*e'
    const char * extended_qual_name=NULL;          // qualified name of the extended entity
      
          // just one of the following can be non false
    if( e->Get_Extend() )   extended_qual_name= e->Get_Extend()->qualified_name();
    if( e->Get_Dynamic() )  extended_qual_name= e->Get_Dynamic()->qualified_name();


                                    // 's' contain the portion of text that substitute '{'

    ostrstream s;
    emit_CPP_info_for_generated_code(s);
    if ( e->Get_Extend() || e->Get_Dynamic() || e->is_extensible() )     // some inheritance must be added
         if ( ! e->Get_ineritance().size()>0 ) // if there isn't any base class
	      s << ':';   // ':' must be added to initiate the base class list
         else
              s << ',';   // ',' must be added to separate the new base class form the old
      
    if (  e->is_extensible() )                           // is it extensible?
         {
         s << " public __Extensible" << " ";
	 }


    if ( e->Get_Extend() || e->Get_Dynamic() )         // does it extend some class?
         {
	 if (e->is_extensible()) s << ",";
         s << " public " << extended_qual_name+2 << "::Extender" << " ";
	 }
   

    s << "{\n";       // the curly must be here
    if ( e->Get_Extend() || e->Get_Dynamic() )
         {
	 s << 
	 "public:\n"
	 "   static ECO_registration_client<" << extended_qual_name+2 << "> registration_id;\n"
	 "private:\n";
	 }
    if ( e->Get_Dynamic() )
         {
	 list<AggregateType_Entity*>* path;
	 AggregateType_Entity* founder= compute_dynamic_chain(e, path );
	 delete path;
	 s << 
	 "public:\n"
	 "   " << founder->name << "* dynamic_this;\n"
	 "private:\n";
	 }

    if ( e->is_extensible() )
         {
	 s <<
	 "public:\n"
         "    static ECO_registration sr;\n"
         "    class Extender: public Generic_Extender \n"
         "        {\n"
         "        public:\n"
	 "        "<< e->name <<"& extended;\n"
         "        Extender("<<e->name<< "& g, ECO_registration_client<"<<e->name<<">& id1, bool f ):\n"
	 "           Generic_Extender(g, id1, f ),\n"
	 "           extended(g)\n"
         "           { }\n"
	 "        virtual ~Extender()\n"
	 "           { }\n"
	 "        Extender* &next_instance() \n"
	 "           { return (Extender*&) Generic_Extender::next_instance();}\n";
	 e->Extender_Methods.C_output(s, 8 ); 
	 s <<
         "        };\n"
         "    Extender** extender_table() const\n"
         "            { return (Extender**) __Extensible::extender_table1(); }\n"
	 "private:\n";
	 
	 AggregateType_Entity* ate= new AggregateType_Entity("Extender");
	 current_scope.add_Entity( ate );
	 }
    emit_CPP_info_for_existant_code(s, leftcurly);
    s << ends;
    S.substitute( leftcurly->begin_token_string, 1, s.str() );
    


                                    // 't' contain the portion of text that substitute '}'

    ostrstream t;
    t << "};\n";                      
    emit_CPP_info_for_generated_code(t);
    if ( (e->Get_Extend()||e->Get_Dynamic()) && define_static_members)   // it extend some class?
	 t << "ECO_registration_client<" << extended_qual_name+2 << "> "<< e_qual_name+2 <<"::registration_id;\n";
    if ( e->is_extensible() && define_static_members)
         t << " ECO_registration " << e_qual_name+2  <<"::sr;\n";     // e_qual_name+2 strip heading '::'
    emit_CPP_info_for_existant_code(t, rightcurly);
    t << ends;
    S.substitute( rightcurly->begin_token_string, 1, t.str() );

    delete extended_qual_name;
    delete e_qual_name;
    };







    void 
Cxx_parser::
emit_CPP_info_for_generated_code(ostream& os)
    {
    static progressive=1;
    os << "\n# " << 1 << " \"ECO" << progressive << "\" 1" << endl; 
    progressive++;
    };

    void 
Cxx_parser::
emit_CPP_info_for_existant_code(ostream& os, A_token t)
    {
    os << "\n# " << t->include_file_line << " \"" << t->include_file << "\" 2" << endl;
    };









    void
Cxx_parser::
modify_function( Entity* e, A_token leftcurly, A_token rightcurly, bool other_initialization )
    {
    if (!can_modify() ) return;
    if ( !e ) return;

    
    if ( e->cl == Entity::Function_E &&        
	      e->get_container()->name.k == Entity_Name::destructor &&
	      e->get_container()->get_container()->cl == Entity::AggregateType &&
	      ((AggregateType_Entity*)e->get_container()->get_container())->is_extensible() )                  // ===== modify destructor
        {                                                                                 //       add something at the begin
	ostrstream s; 
	emit_CPP_info_for_generated_code(s);
	
	s << 
        "     for( int i=0; i<extender_table_size; i++ )\n"
        "         if (extender_table1()[i]!= NULL && !extender_table1()[i]->is_dynamic) \n"   // check for alive extender
        "             throw ECO_exception(ECO_exception::Attempted_deallocation_of_extended_object);\n"
        "     for( int i=0; i<extender_table_size; i++ )\n"
        "         if (extender_table1()[i]!= NULL && extender_table1()[i]->is_dynamic )  \n"   // check for alive S_extender
        "             while( extender_table1()[i]!= NULL ) delete extender_table1()[i];\n";
	
	emit_CPP_info_for_existant_code(s, leftcurly);
	s << ends;
        S.substitute( leftcurly->begin_token_string, 1, s.str() );
        }
    
    else if ( e->cl == Entity::Particular_overloadable_E &&        
	      e->get_container()->name.k == Entity_Name::constructor &&
	      e->get_container()->get_container()->cl == Entity::AggregateType )          // ===== modify constructor
        {                                                                                 //       add something at the begin
	AggregateType_Entity* e1=(AggregateType_Entity*)e->get_container()->get_container();      // AggregateType in which constructor is contained
        const char * e1_qual_name= e1->qualified_name(); // qualified name of the entity '*e1'
        const char * extended_qual_name=NULL;            // qualified name of the extended entity
	  
	char   pre_parameter_name= ' ';     // charcter to emit for generate code to use the parameter
	                                          // it must be ' ' for reference or '*' for pointer
        const char * parameter_name=NULL;
	const char * err_par_name= "unknown";
	
        if( e1->Get_Extend() )   extended_qual_name= e1->Get_Extend()->qualified_name();
        if( e1->Get_Dynamic() )  extended_qual_name= e1->Get_Dynamic()->qualified_name();

	
	Parameters_Entity& ps= ((Particular_overloadable*)e)->T->Parameters;

	
	if ( e1->Get_Extend() || e1->Get_Dynamic() )
	//
	// check if 1st parameter is ok and set 'parameter_name'
	//
	        {   // this block is a cascade of tests
		Entity*          e_par0;
		Type*            t;
		Type*            t2;
		Grouping_Entity* ate;
		
	        if ( ps.Elements.size() < 1 )        // at least one parameter 
		      goto wrong_parameter;
		
	        e_par0= *ps.Elements.begin();
	        if ( e_par0->cl != Entity::Simple )  // the 1st  parameter must be Simple_Entity
		      goto wrong_parameter;
		
		if ( e_par0->name.k != Entity_Name::string )  // The name of the entity must be a string
		      {
		      parameter_name=err_par_name;
		      M::hl_error(M::First_Costr_Parm);
		      }
		else
		      parameter_name=e_par0->name.Get_str();
		
	        t= ((Simple_Entity*)e_par0)->Get_Type();
 	        if ( t->k != Type::pointer && t->k != Type::reference ) // its type must be a pointer or reference
		      goto wrong_parameter_message;
		if ( t->k == Type::pointer ) pre_parameter_name='*';    // pointer must be dereferenced before use
		
                t2= ((Direct_Compound*)t)->inner_type;
		if ( t2->k != Type::aggregate )     // it must point (or reference) to an aggregate
		      goto wrong_parameter_message;    
                
		ate= ((Aggregate*)t2)->TheAggregate;
		if ( e1->Get_Extend() )
		      {
		      if ( e1->Get_Extend() != ate ) // the aggregate must be the same
		             goto wrong_parameter_message;
		      }
		else  // it is an S-extender (dynamic hierarchy)
		      {
                      list<AggregateType_Entity*>* path;
		      AggregateType_Entity* founder= compute_dynamic_chain( e1, path );
		      delete path;
		      if ( founder != ate ) // the aggregate must be the same
		             goto wrong_parameter_message;
		      }
		    
		goto right_parameter;  // all is ok, exit from the block doing nothing
		    
	        // there are three way to exit from this block	    
                      wrong_parameter:          // set name to "unknown" and emit error message
                         parameter_name= err_par_name;
                      wrong_parameter_message:  // emit error message
                         M::hl_error( M::First_Costr_Parm );
                      right_parameter:          // do nothing
		         ;
		}
	

	ostrstream s; 
	emit_CPP_info_for_generated_code(s);
	
	if ( e1->is_extensible() )
	      {
	      if ( other_initialization ) s << ", "; else s << ": ";
              s <<  "__Extensible(sr.get_next())\n";
	      other_initialization= true;
	      }
	
	if ( e1->Get_Extend()  )
	      {
	      if ( other_initialization ) s << ", "; else s << ": ";
              s << extended_qual_name+2 << "::Extender("<<pre_parameter_name << parameter_name << ", registration_id, false)\n" ;
	      other_initialization= true;
	      } 
	else if ( e1->Get_Dynamic() )
	      {
	      list<AggregateType_Entity*>* path;
	      AggregateType_Entity* founder= compute_dynamic_chain( e1, path );   // path must contain at least two element because the condition above

	      if ( other_initialization ) s << ", "; else s << ": ";
	      s << "dynamic_this( &"<< pre_parameter_name << parameter_name  << " ),";
              s << extended_qual_name+2 << "::Extender(";
	      if ( path->size() >2 )
		   {
	           char *left, *right;
	           out_extender_table_chain( left, right, ++ path->begin(), -- -- path->end() );
	           s << "*" << left <<"(" <<  pre_parameter_name << parameter_name  << ")." << right;
	           delete left; delete right;
		   }
	      else 
		   s << pre_parameter_name << parameter_name;
	      s <<", registration_id, true)\n" ;
	      other_initialization= true;
	      delete path;
	      }
	      
        s << "{\n";
	
	emit_CPP_info_for_existant_code(s, leftcurly);
	s << ends;
        S.substitute( leftcurly->begin_token_string, 1, s.str() );
	}
    };




// this compute the correct entity for the name of the member
      Entity*
Cxx_parser::
compute_entity( const AggregateType_Entity* E1, const A_name_entity& E2 ) const
      {
      if ( E2.e && E2.e->get_container()==(Entity_Container*)E1) 
	 return E2.e;
      else
	 return E1->Local_Name_LookUp( *E2.name );
      }






// This compute the path from "founder" (at the top of the hierarchy)
// to "descendant" (at the bottom of the hierarchy).
// The result is a new list created and the pointer is stored in "path".
// The return value is the "founder" which is also the first element of the list
//   the list contain at least one element.
    
      AggregateType_Entity*
Cxx_parser::
compute_dynamic_chain(AggregateType_Entity* descendant,
		      list<AggregateType_Entity*>* &path ) const
      {
      path= new list<AggregateType_Entity*>;
      AggregateType_Entity* current= descendant;
      do
	  {
	  path->push_front(current);
	  current= current->Get_Dynamic();
	  }
      while ( current );
      return *path->begin();  
      }




// PRECONDITION
// ------------
//  "from" and "to" must appertain to the same list and "from" must be befor or equal to "to".
//   no consistency check is performed.
// OUTPUT
// ------
//   two new string are allocate and pointers are setted to it ("left", "right")
// 
// EXPLANATION
// -----------
// this function could be more simple if it was possible to write a chain like the following:
//
//  extender_table[..]->extender_table[..]->extender_table[..]->...
//
// it is impossible due to pointer conversion needed then before each "->" we must put a
// form like this  ((Child*)( ... extender_table[..]))->
//
// This is a << RECURSIVE FUNCTION >>
// 
// Inner calls of the function create inner parte of the expression (and first elements of
//   the above cited and not correct expression)
//
//
// --- base step:
//
// Give from==to and (*to) point to an entity an entity which name is "LastChild"
// the following function return two string "left" (the left part) and "right"
// (the right part)
//
//
//  ((LastChild*)(         ...            extender_table[ LastChild::registration_id.id ]))
//   left part          center part            right_part
//
//
// --- recursive step:
//
// Give from!=to and (*to) point to an entity an entity which name is "Child"
// the following function return two string "left" (the left part) and "right"
// (the right part) created from a recursive call of the function in the following way:
// "left1" and "right1" are the result of the recursive call with "--to"
//
//  ((Child*)(    ...          ...           ... ->    extender_table[ Child::registration_id.id ]))
//              left1                       right1      
//       left part          center part         right_part
//
//  left part is like base step exept for  adding  "left1" to its left
//  right part is created by adding  "right1" to its right
//
//


      void
Cxx_parser::               
out_extender_table_chain(char* &left,
			 char* &right,
			 list<AggregateType_Entity*>::iterator from,
			 list<AggregateType_Entity*>::iterator to) const
      {
      ostrstream New_Left, New_Right;
      char *left1;
      char *right1;
      if ( from!=to )
	  {
	  list<AggregateType_Entity*>::iterator to2=to;
	  --to2;
          out_extender_table_chain( left1, right1, from, to2);   // recursive step
	  }
      else
	  { left1= new char('\0'); right1= new char('\0'); }     // null strings for base step
      
      const char * n=(*to)->qualified_name();
      New_Left << "((" << n << "*)(" << left1 << ends;
      New_Right << right1 << ( from!=to? "->": "" ) << "extender_table()["<< n << "::registration_id.id ]))" << ends;

      delete left1; delete right1; delete n;
      left= New_Left.str();
      right= New_Right.str();
      
      }





// if ( E1.k==A_objec::get_pointer ) E2 is ignored
      Type* 
Cxx_parser::
modify_access( const A_object& E1, const A_name_entity& E2 )        // modify an access to a member (changes occours only for dynamic inheritance )
      {
      if (!can_modify() ) return new Built_in(Error);

      Type* return_type=NULL;
      if ( E1.primary.t->is_equal( &Built_in(Error)) )   // if E1 is already an error
	   {
	   switch( E1.k )
	        {
		case A_object:: get_pointer:
		case A_object:: point_dynamic:
		case A_object:: pointsat_dynamic:
		    M::hl_error(M::Too_Complex);
		    break;
		default:
		    break;
		}
	   return_type=E1.primary.t;
	   }
      else
	   {
	   
	   
	   Type* type2;
           if ( E1.primary.t->k==Type::reference )     // a reference has no effect, strip it
           	 {
           	 type2= ((Reference*)E1.primary.t)->inner_type;
           	 ((Reference*)E1.primary.t)->inner_type=NULL;
           	 delete E1.primary.t;
           	 }
           else
           	 type2=E1.primary.t;
	   


	   
	   bool it_was_a_pointer= (type2->k == Type::pointer);     
	   Type* type3;
	   if (it_was_a_pointer )                   // strip pointer if necessary
           	 {
           	 type3= ((Pointer*)type2)->inner_type;
           	 ((Pointer*)type2)->inner_type=NULL;
           	 delete type2;
           	 }
           else
           	 type3=type2;
	   type2=NULL; // no more valid



           if ( it_was_a_pointer && ( E1.k== A_object::point || E1.k== A_object::point_dynamic ||  E1.k== A_object::get_pointer ) )
	         { // it is an error
		 }
	   if ( E1.k== A_object::point ||  E1.k== A_object::pointsat )
	         {
	         if (       type3->k == Type::aggregate &&     // new can be an aggregate or an enum
	                    ((Aggregate*)type3)->TheAggregate->cl == Entity::AggregateType   // it is realy an aggregate
		    )
		      {
                      AggregateType_Entity* first= (AggregateType_Entity*) ((Aggregate*)type3)->TheAggregate;
		      Entity* member= compute_entity( first, E2 );
		      if ( member ) return_type= get_type_from_entity( member );
		      }
		 }
	   else if ( E1.k== A_object::point_dynamic ||  E1.k== A_object::pointsat_dynamic )
	         {
	         if (    type3->k == Type::aggregate &&     // new can be an aggregate or an enum
	                 ((Aggregate*)type3)->TheAggregate->cl == Entity::AggregateType &&   // it is realy an aggregate
	                 E1.e->cl == Entity::AggregateType 
		    )
		      {
                      AggregateType_Entity* first= (AggregateType_Entity*) ((Aggregate*)type3)->TheAggregate;
		      list<AggregateType_Entity*>* path;
		      AggregateType_Entity* founder= compute_dynamic_chain( (AggregateType_Entity*)E1.e, path );
		      if (founder==first)
			   {
		           Entity* member= compute_entity( *(--path->end()), E2 );
		           if ( member )
			       {  //=============== modify the source.
			       return_type= get_type_from_entity( member );
			       
			       ostrstream s;
			       s << (it_was_a_pointer? "->" : ".");       
			       char *left, *right;
			       out_extender_table_chain( left, right, ++ path->begin(), -- path->end() );
			       s << right << "->"<< ends; delete right;
			       S.substitute( E1.primary.begin, 0, left );
			       S.substitute( E1.begin_oper, E1.end_oper-E1.begin_oper+1, s.str() );
			       }
			   else
			       M::hl_error(M::Wrong_member);
			   }
		      delete path;
		      }
		 }
	   else if ( E1.k== A_object::get_pointer )
	         {
	         if (    type3->k == Type::aggregate &&     // new can be an aggregate or an enum
	                 ((Aggregate*)type3)->TheAggregate->cl == Entity::AggregateType &&   // it is realy an aggregate
	                 E1.e->cl == Entity::AggregateType
		    )
		      {
                      AggregateType_Entity* first= (AggregateType_Entity*) ((Aggregate*)type3)->TheAggregate;
		      list<AggregateType_Entity*>* path;
		      AggregateType_Entity* founder= compute_dynamic_chain( (AggregateType_Entity*)E1.e, path );
		      if (founder==first)
			       {  //=============== modify the source.
			       return_type= new Pointer;
			       return_type->set_inner( get_type_from_entity( E1.e ) );
                   			       
			       ostrstream Left, Right;
			       Left << "( (" <<  ((AggregateType_Entity*)E1.e)->name <<"*) "<< ends;
			       Right <<".__deep_get_IExtenderPtr( "<< path->size()-1;
			       for( list<AggregateType_Entity*>::iterator i= ++ path->begin(); i!= path->end(); ++i )
				   Right << ", " <<  (*i)->name << "::registration_id.id";
			       Right << ") )" << ends;
			       S.substitute( E1.primary.begin, 0, Left.str() );
			       S.substitute( E1.begin_oper, E1.end_oper-E1.begin_oper+1, Right.str() );
			       }
		      delete path;
		      }
		 }
	   else
                 M::winternal("modify_access: bad value of A_object::k ");
	   
	   delete type3;
	   
           }

      
      if( !return_type ) return_type= new Built_in(Error);
      return return_type;
      }

  
   
      Type* 
Cxx_parser::
modify_access( const A_object& E1, const A_name_entity_scope& E2 )        // modify an access to a member (changes occours only for dynamic inheritance )
      {
      A_name_entity temp;
      temp.name= E2.name;
      temp.e= E2.e;
      return modify_access( E1, temp );
      }
